///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/ILXCrashFinder/ILXCrashFinder.cpp,v 1.1 2004/09/07 06:08:22 me133 Exp $
//
//    File name:	ILXCrashFinder.cpp
//   Created By:	Zakir Hussain
//   Created On:	7/17/2002 1:28:23 PM
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: ILXCrashFinder.cpp,v $
 * Revision 1.1  2004/09/07 06:08:22  me133
 * o Initial checkin to CVS
 * 
 * 
 * 18    8/16/02 3:37p Zakirh
 * o Fixed the compile error in Win Release Mode.
 * 
 * 17    8/05/02 4:10p Zakirh
 * o Initialise the pdbInfo to not available
 * 
 * 16    8/05/02 3:31p Zakirh
 * o now uses DbgHelp.dll instead of imageHlp.dll
 * o included all the review feedback
 * o Added support to detect older and newer pdb 
 * o code cleanup
 * 
 * 15    7/26/02 8:04p Zakirh
 * o Xtra arguement check.
 * 
 * 14    7/26/02 2:25p Zakirh
 * o NULL terminate all string.
 * 
 * 13    7/25/02 3:58p Marce
 * o Fixed bug where exception pointer was being modified by _StackWalk()
 * call.  This prevented us from calling GetExceptionInfo() twice with the
 * same ptr.
 * o Made argument const
 * 
 * 12    7/25/02 3:01p Marce
 * o Made argument const
 * 
 * 11    7/25/02 2:03p Zakirh
 * o commented code.
 * o code cleanup. 
 * o removed unused headers.
 * 
 * 10    7/24/02 6:32p Marce
 * o Comment change
 * 
 * 9     7/24/02 2:48p Zakirh
 * o Code CleanUp and New structure format as per marc's request.
 * 
 * 8     7/23/02 5:47p Zakirh
 * o Fixed the bug where if the crash happens in MFC DLL's Crash Finder
 * fails.
 * 
 * 7     7/19/02 5:26p Zakirh
 * o On Exit Release the IMGHLP library.
 * 
 * 6     7/18/02 6:48p Zakirh
 * o added a new method to truncate the path.
 * 
 * 5     7/18/02 2:57p Zakirh
 * o Initialise address value.
 * 
 * 4     7/18/02 2:39p Zakirh
 * added address to the Stack Frame.
 * 
 * 3     7/17/02 7:00p Zakirh
 * o New API Definition now uses Structure.
 */


// ILXCrashFinder.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"						//pch
#include "ILXCrashFinder.h"				//Me 
#include <time.h>						//for time related 
#include <tchar.h>						//for all tchar routines
#ifndef _UNICODE
#include <stdlib.h>						//this is for ansi version of tchar routines
#endif


	// Make typedefs for some IMAGEHLP.DLL functions so that we can use them
	// with GetProcAddress
	typedef BOOL (__stdcall * SYMINITIALIZEPROC)
			( HANDLE, LPSTR, BOOL ); //SymIntialize

	typedef BOOL (__stdcall *SYMCLEANUPPROC)
			( HANDLE ); //SymCleanup

	typedef BOOL (__stdcall * STACKWALKPROC)
			( DWORD, HANDLE, HANDLE, LPSTACKFRAME, LPVOID,
			PREAD_PROCESS_MEMORY_ROUTINE,PFUNCTION_TABLE_ACCESS_ROUTINE,
			PGET_MODULE_BASE_ROUTINE, PTRANSLATE_ADDRESS_ROUTINE ); //StackWalk

	typedef LPVOID (__stdcall *SYMFUNCTIONTABLEACCESSPROC)
			( HANDLE, DWORD ); //SymFunctionTableAccess.

	typedef DWORD (__stdcall *SYMGETMODULEBASEPROC)
			( HANDLE, DWORD );//SymGetModuleBase.

	typedef BOOL (__stdcall *SYMGETSYMFROMADDRPROC)
			( HANDLE, DWORD, PDWORD, PIMAGEHLP_SYMBOL );//SymGetSymFromAddr.

	typedef BOOL (__stdcall * SYMGETLINEFROMADDRPROC) 
			( HANDLE, DWORD, PDWORD, PIMAGEHLP_LINE );//SymGetLineFromAddr

	typedef BOOL (__stdcall * SYMGETMODULEINFOPROC) 
			( HANDLE, DWORD, PIMAGEHLP_MODULE );//SymGetModuleInfo
	
	typedef DWORD (__stdcall * SYMSETOPTIONSPROC ) 
			( DWORD );	//SymSetOptions

	typedef DWORD (__stdcall * SYMGETOPTIONSPROC ) 
			( VOID ); //SymGetOptions

	//Begin private methods 

	static BOOL ImagehlpStackWalk( 
		const PCONTEXT					pContextArg, 
		HANDLE							hProcess, 
		PILXStackFrame					paryStackFrames, 
		long							lMaxStackSize,
		STACKWALKPROC					MyStackWalk,
		SYMFUNCTIONTABLEACCESSPROC		MySymFunctionTableAccess,
		SYMGETMODULEBASEPROC			MySymGetModuleBase,
		SYMGETSYMFROMADDRPROC			MySymGetSymFromAddr,
		SYMGETLINEFROMADDRPROC			MySymGetLineFromAddr,
		SYMGETMODULEINFOPROC			MySymGetModuleInfo);

	static BOOL GetLogicalAddress( PVOID addr, TCHAR* szModule, DWORD len, TCHAR* szFullModuleName );

	static BOOL InternalSymGetLineFromAddr (  
		HANDLE					hProcess,
		DWORD					dwAddr,
		PDWORD					pdwDisplacement, 
		PIMAGEHLP_LINE			Line,
		SYMGETLINEFROMADDRPROC	MySymGetLineFromAddr );

	static void TruncatePath( TCHAR* szSrc, TCHAR *szDest ); //in src -- out dest

	static BOOL GetModuleInformation( HANDLE hProcess, DWORD dwAddr, TCHAR * szFullModule, PDBINFO *pPdbInfo, SYMGETMODULEINFOPROC MySymGetModuleInfo );

//End private methods

//*********************************************************************
// FUNCTION		:	DllMain
//					
// DESCRIPTION	:	Main entry poin into the DLL.
//					
// RETURNS		:	
//					TRUE ALWAYS
//					
// PARAMETERS	:	
//					
//					
// COMMENTS		:	
//					
//*********************************************************************

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		{
			// I don't need the thread notifications.
            DisableThreadLibraryCalls ( ( HINSTANCE )hModule ) ;
			break;
		}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

//*********************************************************************
// FUNCTION		:	GetExceptionInfo
//					
// DESCRIPTION	:	The exported function called by clients.
//					o Initialise the ImageHlp functions dynamically.
//					o Get the current process handle
//					o Set the Options for the Symbol loader ( Deferred load ...et al )
//					o Initliase the Symbol Loader
//					o Walk the stack
//					
// RETURNS		:	
//					HRESULT for custom codes refer to header file.
//					
// PARAMETERS	:	
//					EXCEPTION_POINTERS*	pExceptionInfo:-[IN]	
//						Contains Execption Information. Obtained 
//					From a catch block.
// 
//					TCHAR*	szSearchPath:-[IN]
//						Search Path could be NULL. Advisable to be a TCHAR array.
//					more than one path can be specified by separating them with a 
//					semicolon
//
//					PILXStackFrame paryStackFrames:-[IN,OUT]
//						Array of stack frames. Advisable to keep this memory
//					in stack rather than heap.
//
//					long nStackFrames:-[IN]
//						Number of Stack Frames to return
//					
// COMMENTS		:	
//					
//*********************************************************************

ILXCRASHFINDER_API HRESULT GetExceptionInfo (	
	/*[in]*/     const EXCEPTION_POINTERS*	pExceptionInfo,	//Execption Information 
	/*[in]*/     const TCHAR*				szSearchPath,	//Search Path
	/*[in,out]*/  PILXStackFrame			paryStackFrames,//array of stack frames
	/*[in]*/     long						nStackFrames)	//Stack Depth 
{

	//check the arguements 
	if ( !pExceptionInfo || ( nStackFrames <= 0 ) || !paryStackFrames )
	{
		return E_INVALIDARG;
	}

	if ( !pExceptionInfo->ExceptionRecord || !pExceptionInfo->ContextRecord )
	{
		return E_INVALIDARG;
	}

	if ( !szSearchPath )
	{
		return E_INVALIDARG;
	}

	HRESULT hr = S_OK;

	//ImageHlp.dll loaded Module Handle
	HMODULE hModImagehlp			= 0; 
	

	//declare the function pointers into the actual imageHlp.dll
	SYMINITIALIZEPROC				MySymInitialize				=	0;
	SYMCLEANUPPROC					MySymCleanup				=	0;
	STACKWALKPROC					MyStackWalk					=	0;
	SYMFUNCTIONTABLEACCESSPROC		MySymFunctionTableAccess	=	0;
	SYMGETMODULEBASEPROC			MySymGetModuleBase			=	0;
	SYMGETSYMFROMADDRPROC			MySymGetSymFromAddr			=	0;
	SYMGETLINEFROMADDRPROC			MySymGetLineFromAddr		=	0;
	SYMGETMODULEINFOPROC			MySymGetModuleInfo			=	0;
	SYMSETOPTIONSPROC				MySymSetOptions				=	0;
	SYMGETOPTIONSPROC				MySymGetOptions				=	0;

	//dynamic loading of the dll no static linking as per marces request 
	//if the dll is not present get out and return an error to the user

	//we are loading dbghelp.dll instead of imagehlp because of NT clients
	//they have a inferior imagehlp.dll installed and some of the methods
	//are not avilable and this dll cannot be easily updated because some system process
	//always uses this DLL so instead we load dbghelp.dll which is redistributable
	//
	hModImagehlp = LoadLibrary( _T("DBGHELP.DLL") );
    if ( !hModImagehlp )
	{
		hr = MAKE_HRESULT( SEVERITY_ERROR, FACILITY_ITF, DBG_HLP_DLL_NOTFOUND );
        return hr;
	}

	//NO UNICODE VERSION AVAILABLE FOR GetProcAddress 
    MySymInitialize = (SYMINITIALIZEPROC)GetProcAddress( hModImagehlp, "SymInitialize" );
    MySymCleanup = (SYMCLEANUPPROC)GetProcAddress( hModImagehlp, "SymCleanup" );
    MyStackWalk = (STACKWALKPROC)GetProcAddress( hModImagehlp, "StackWalk" );
    MySymFunctionTableAccess = (SYMFUNCTIONTABLEACCESSPROC)GetProcAddress( hModImagehlp, "SymFunctionTableAccess" );
    MySymGetModuleBase = (SYMGETMODULEBASEPROC)GetProcAddress( hModImagehlp,"SymGetModuleBase" );
    MySymGetSymFromAddr = (SYMGETSYMFROMADDRPROC)GetProcAddress( hModImagehlp,"SymGetSymFromAddr" );
	MySymGetLineFromAddr = (SYMGETLINEFROMADDRPROC)GetProcAddress( hModImagehlp,"SymGetLineFromAddr" );
	MySymGetModuleInfo = (SYMGETMODULEINFOPROC) GetProcAddress( hModImagehlp,"SymGetModuleInfo" );
	MySymSetOptions = (SYMSETOPTIONSPROC) GetProcAddress( hModImagehlp, "SymSetOptions" );
	MySymGetOptions = (SYMGETOPTIONSPROC) GetProcAddress( hModImagehlp, "SymGetOptions" );

	//check all the values 
	if ( !MySymGetOptions || !MySymSetOptions || !MySymGetModuleInfo 
		|| !MySymGetLineFromAddr || !MySymGetSymFromAddr || !MySymGetModuleBase 
		|| !MySymFunctionTableAccess || !MyStackWalk || !MySymCleanup || !MySymInitialize )
	{
		hr = MAKE_HRESULT( SEVERITY_ERROR, FACILITY_ITF, DBG_HLP_DLL_NOTFOUND );
        return hr;        
	}

	//get the current process no specific error return value hence cannot check for error
	HANDLE hProcess = GetCurrentProcess();
	
	//set the symbol load options 
	DWORD dwOpts = MySymGetOptions() ;
    MySymSetOptions ( dwOpts|SYMOPT_LOAD_LINES|SYMOPT_OMAP_FIND_NEAREST|SYMOPT_DEFERRED_LOADS) ;

	char chSearchPath[MAX_PATH];
	ZeroMemory( chSearchPath, sizeof(chSearchPath) );

	#ifdef _UNICODE
	//convert from unicode to char *
	WideCharToMultiByte(0, 0, szSearchPath, -1, chSearchPath, sizeof( chSearchPath ), 0, 0);
	#else
	_tcsncpy( chSearchPath,szSearchPath,MAX_PATH);
	//use it as it is 
	#endif	

	//null terminate the string converted
	chSearchPath[MAX_PATH-1] = '\0';

	//first do symbol initialisation and load the modules
	//this is ansi method so convert to char * always while using 
	BOOL bRet = MySymInitialize( hProcess, chSearchPath, TRUE );
	if ( !bRet )
	{
		//no need to do a SymCleanUp but free up the library
		if ( hModImagehlp )
		{
			FreeLibrary( hModImagehlp );
		}

		//symInitialise failed 
		hr = MAKE_HRESULT( SEVERITY_ERROR, FACILITY_ITF, SYM_INIT_FAILED );
		return hr;
	}

	//because of deffered load we have to make a hit to the suymbol table
	//so that GetModule will Succeed 
	BYTE symbolBuffer[ sizeof(IMAGEHLP_SYMBOL) + MAX_FUNCTION_NAME_LEN ];
    PIMAGEHLP_SYMBOL pSymbol = (PIMAGEHLP_SYMBOL)symbolBuffer;
    pSymbol->SizeOfStruct = sizeof(symbolBuffer);
    pSymbol->MaxNameLength = MAX_FUNCTION_NAME_LEN;
	DWORD dwFnDispl = 0; //Function displacement
	//save the address
	DWORD  dwAddress = reinterpret_cast<DWORD>(pExceptionInfo->ExceptionRecord->ExceptionAddress); //save the look up address
    bRet = MySymGetSymFromAddr( hProcess, dwAddress, &dwFnDispl, pSymbol );

	//so user needs stack trace ...

	//lets start tracing the stack
	bRet = ImagehlpStackWalk( pExceptionInfo->ContextRecord, hProcess, paryStackFrames, 
		nStackFrames, MyStackWalk, MySymFunctionTableAccess, MySymGetModuleBase,
		MySymGetSymFromAddr, MySymGetLineFromAddr, MySymGetModuleInfo );

	//Finally cleanup everything 
	MySymCleanup ( hProcess );

	//if valid then free the library
	if ( hModImagehlp )
	{
		FreeLibrary( hModImagehlp );
	}

	if ( !bRet )
	{
        hr = MAKE_HRESULT( SEVERITY_ERROR, FACILITY_ITF, STACKWALK_FAILED );
		return hr;
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	ImagehlpStackWalk
//					
// DESCRIPTION	:	
//					o Initliase the STACKFRAME structure for apprpriate processor
//					o Walk the stack with the context record.
//					o For each context record till Max size requested
//						Get the module and symbol information. 
//					o Fill the Stack data strcuture passed.
//					
// RETURNS		:	
//					BOOL - TRUE success FALSE failure.
//					
// PARAMETERS	:	
//					PCONTEXT pContext, 
//					Exception Context Record.
//
//					HANDLE hProcess, 
//					Handle of the Current Process.
//
//					PILXStackFrame paryStackFrames:-[IN,OUT]
//					Stack Frames.
//
//					long lMaxStackSize:-[IN]
//					Number of stack frames to return.									
//					
//					STACKWALKPROC MyStackWalk:-[IN]
//					Proc Address for StackWalk
//
//					SYMFUNCTIONTABLEACCESSPROC MySymFunctionTableAccess:-[IN]
//					Proc Address for SymFunctionTableAccess
//
//					SYMGETMODULEBASEPROC MySymGetModuleBase:-[IN]
//					Proc Address for SymGetModuleBase
//
//					SYMGETSYMFROMADDRPROC MySymGetSymFromAddr:-[IN]
//					Proc Address for SymGetSymFromAddr
//
//					SYMGETLINEFROMADDRPROC MySymGetLineFromAddr:-[IN]
//					Proc Address for SymGetLineFromAddr
//
//					SYMGETMODULEINFOPROC MySymGetModuleInfo:-[IN]
//					Proc Address for SymGetModuleInfo
//
// COMMENTS		:	
//					
//*********************************************************************

BOOL ImagehlpStackWalk( 
	const PCONTEXT					pContextArg, 
	HANDLE							hProcess, 
	PILXStackFrame					paryStackFrames, 
	long							lMaxStackSize,
	STACKWALKPROC					MyStackWalk,
	SYMFUNCTIONTABLEACCESSPROC		MySymFunctionTableAccess,
	SYMGETMODULEBASEPROC			MySymGetModuleBase,
	SYMGETSYMFROMADDRPROC			MySymGetSymFromAddr,
	SYMGETLINEFROMADDRPROC			MySymGetLineFromAddr,
	SYMGETMODULEINFOPROC			MySymGetModuleInfo)
{
	//arg check
	if ( !MyStackWalk || !MySymFunctionTableAccess || !MySymGetModuleBase ||
		!MySymGetSymFromAddr || !MySymGetLineFromAddr || !pContextArg || !paryStackFrames )
	{
		return FALSE;
	}

	// Create a temporary copy of CONTEXT and use that since _StackWalk()
	// will overwrite its data
	CONTEXT contextCopy = *pContextArg;
	PCONTEXT pContext = &contextCopy;
	
    // Could use SymSetOptions here to add the SYMOPT_DEFERRED_LOADS flag
	STACKFRAME sf;
	ZeroMemory( &sf, sizeof( STACKFRAME) );

    // Initialize the STACKFRAME structure for the first call.  This is only
    // necessary for Intel CPUs, and isn't mentioned in the documentation.
	#ifdef _X86_
		sf.AddrPC.Offset       = pContext->Eip;
		sf.AddrStack.Offset    = pContext->Esp;
		sf.AddrFrame.Offset    = pContext->Ebp;
	#else
		sf.AddrPC.Offset       = (DWORD)pExPtrs->ContextRecord->Fir ;
		sf.AddrReturn.Offset   = (DWORD)pExPtrs->ContextRecord->IntRa;
		sf.AddrReturn.Mode     = AddrModeFlat ;
		sf.AddrStack.Offset    = (DWORD)pExPtrs->ContextRecord->IntSp;
		sf.AddrFrame.Offset    = (DWORD)pExPtrs->ContextRecord->IntFp;
	#endif
	sf.AddrPC.Mode         = AddrModeFlat;
	sf.AddrStack.Mode      = AddrModeFlat;
	sf.AddrFrame.Mode      = AddrModeFlat;

	int nCount = 0;

	//start walking the stack 
    while ( nCount < lMaxStackSize )
    {
		//Set All Default values to the out params in the structure 
		paryStackFrames[nCount].szModuleName[0]		= NULL_CHAR;
		paryStackFrames[nCount].szFunctionName[0]	= NULL_CHAR;
		paryStackFrames[nCount].szFilePath[0]		= NULL_CHAR;
		paryStackFrames[nCount].lLineNumber			= 0;
		paryStackFrames[nCount].lColNumber			= 0;
		paryStackFrames[nCount].dwAddress			= 0;
		paryStackFrames[nCount].enumPdbInfo			= enumPdbInfoNotAvailable;
		
		//Get all IN parameters from the structure
		long lMaxModuleNameLen		= sizeof( paryStackFrames[nCount].szModuleName ) / sizeof( paryStackFrames[nCount].szModuleName[0] ) ;
		long lMaxFunctionNameLen	= sizeof( paryStackFrames[nCount].szFunctionName ) / sizeof( paryStackFrames[nCount].szFunctionName[0] ) ;
		long lMaxFilePath			= sizeof( paryStackFrames[nCount].szFilePath ) / sizeof( paryStackFrames[nCount].szFilePath[0] ) ;

		if ( ( lMaxModuleNameLen <= 0 ) || ( lMaxFunctionNameLen <= 0 ) || ( lMaxFilePath <= 0 ) )
		{
			//no point continuing if user has set negative or 0 values 
			//so get out
			return FALSE;
		}

		BOOL bIsDirty = FALSE;

        if ( ! MyStackWalk(  CH_MACHINE,
                            hProcess,
                            GetCurrentThread(),
                            &sf,
                            pContext,
                            0,
                            MySymFunctionTableAccess,
                            MySymGetModuleBase,
                            0 ) )
            break;

        if ( 0 == sf.AddrFrame.Offset ) // Basic sanity check to make sure
            break;                      // the frame is OK.  Bail if not.


		//store the address
		paryStackFrames[nCount].dwAddress = sf.AddrPC.Offset;
		
		// Step 1 get the Module Name 
		//get module information first 
        TCHAR szModule[MAX_PATH];
		ZeroMemory( szModule, MAX_PATH );

		TCHAR szFullModule[MAX_PATH];
		ZeroMemory( szFullModule, MAX_PATH );

        BOOL bRet = GetLogicalAddress(  (PVOID)sf.AddrPC.Offset, szModule, sizeof(szModule), szFullModule );
		if ( bRet ) 
		{
			_tcsncpy( paryStackFrames[nCount].szModuleName, szModule, lMaxModuleNameLen );

			//null terminate it any ways 
			paryStackFrames[nCount].szModuleName[lMaxModuleNameLen - 1] = NULL_CHAR;

			bIsDirty = TRUE;
		}
	
		// get PDB time stamp 
		long lPdbInfo =0;// 0 = means same, -1 means older pdb, 1 means newer pdb 
		bRet = GetModuleInformation( hProcess, sf.AddrPC.Offset, szFullModule, &(paryStackFrames[nCount].enumPdbInfo), MySymGetModuleInfo );
		if ( bRet )
		{
			bIsDirty = TRUE;
		}


		// Step 2 Get the Function Information 

        // IMAGEHLP is wacky, and requires you to pass in a pointer to a
        // IMAGEHLP_SYMBOL structure.  The problem is that this structure is
        // variable length.  That is, you determine how big the structure is
        // at runtime.  This means that you can't use sizeof(struct).
        // So...make a buffer that's big enough, and make a pointer
        // to the buffer.  We also need to initialize not one, but TWO
        // members of the structure before it can be used.
		BYTE symbolBuffer[ sizeof(IMAGEHLP_SYMBOL) + MAX_FUNCTION_NAME_LEN ];	
        PIMAGEHLP_SYMBOL pSymbol = (PIMAGEHLP_SYMBOL)symbolBuffer;
        pSymbol->SizeOfStruct = sizeof(symbolBuffer);
        pSymbol->MaxNameLength = lMaxFunctionNameLen;
        DWORD symDisplacement = 0;  // Displacement of the input address,
                                    // relative to the start of the symbol
        if ( MySymGetSymFromAddr( hProcess, sf.AddrPC.Offset, &symDisplacement, pSymbol ) )
        {
			

			#ifdef _UNICODE
				//write into temporary buffer 
				TCHAR chTempBuf[MAX_FUNCTION_NAME_LEN];
				ZeroMemory( chTempBuf, sizeof( chTempBuf ) );
				int nRet= MultiByteToWideChar(0, 0, pSymbol->Name, -1, chTempBuf, sizeof(chTempBuf) );		
				chTempBuf[MAX_FUNCTION_NAME_LEN-1] = NULL_CHAR;
				if ( nRet > 0 )
				{
					_tcsncpy( paryStackFrames[nCount].szFunctionName, chTempBuf, lMaxFunctionNameLen );
					bIsDirty = TRUE;
				}
			#else
				_tcsncpy( paryStackFrames[nCount].szFunctionName, pSymbol->Name, lMaxFunctionNameLen );
				bIsDirty = TRUE;
			#endif
		
			//null terminate it any ways 
			paryStackFrames[nCount].szFunctionName[lMaxFunctionNameLen - 1] = NULL_CHAR;

			// Step 3 Get the Line Information 
			// Look up the line stuff.
			IMAGEHLP_LINE stIHLine;		
			ZeroMemory( &stIHLine, sizeof ( IMAGEHLP_LINE ) );
			stIHLine.SizeOfStruct = sizeof ( IMAGEHLP_LINE ) ;
			DWORD dwSrcDispl = 0;
			bRet = InternalSymGetLineFromAddr( hProcess, sf.AddrPC.Offset, &dwSrcDispl, &stIHLine, MySymGetLineFromAddr );
			if ( bRet )
			{
				#ifdef _UNICODE
					//write into temporary buffer 
					TCHAR chTempBuf[MAX_FUNCTION_NAME_LEN];
					ZeroMemory( chTempBuf, sizeof( chTempBuf ) );
					int nRet= MultiByteToWideChar(0, 0, stIHLine.FileName, -1, chTempBuf, sizeof(chTempBuf) );		
					chTempBuf[MAX_FUNCTION_NAME_LEN-1] = NULL_CHAR;
					if ( nRet > 0 )
					{
						_tcsncpy( paryStackFrames[nCount].szFilePath, chTempBuf, lMaxFilePath );
					}
				#else
					_tcsncpy( paryStackFrames[nCount].szFilePath, stIHLine.FileName, lMaxFilePath );
				#endif

				//set the line number and column number
				paryStackFrames[nCount].lLineNumber		=	stIHLine.LineNumber;
				paryStackFrames[nCount].lColNumber		=	dwSrcDispl;

				//null terminate it any ways 
				paryStackFrames[nCount].szFilePath[lMaxFilePath - 1] = NULL_CHAR;				

				bIsDirty = TRUE;
			}
	    }

		//only if dirty increment the count
		if ( bIsDirty )
			nCount++;
    }

	//set the rest of the stack to null 
	while ( ++nCount < lMaxStackSize ) //in case stack size was too big.
	{
		::ZeroMemory( &paryStackFrames[nCount], sizeof( paryStackFrames[nCount] ) );
		paryStackFrames[nCount].enumPdbInfo		= enumPdbInfoNotAvailable;
	}

	return TRUE;
}


//*********************************************************************
// FUNCTION		:	GetModuleInformation
//					
// DESCRIPTION	:	
//					This method determines compares the pdb time stamp
//					to DLL timestamp.
//					
// RETURNS		:	
//					BOOL - TRUE success FALSE failure.
//					
// PARAMETERS	:	
//					HANDLE hProcess:-[IN]
//					Handle of the current process
//
//					DWORD dwAddr, 
//					Address where the crash occurred
//
//					TCHAR * szFullModule:-[IN]
//					Full module Name where the crash occurred
//
//					PDBINFO *pPdbInfo:-[IN/OUT]
//					based on the time stamp of the dll and pdb 
//					this value could be 
//					0	same
//					-1	pdb is older than the dll
//					1   pdb is newer than the dll
//
//					SYMGETMODULEINFOPROC MySymGetModuleInfo:-[IN]
//					Proc Address for SymGetModuleInfo
//
// COMMENTS		:	
//					
//*********************************************************************

BOOL GetModuleInformation( HANDLE hProcess, DWORD dwAddr, TCHAR * szFullModule, PDBINFO *pPdbInfo, SYMGETMODULEINFOPROC MySymGetModuleInfo )
{
	if ( !szFullModule || !pPdbInfo || !MySymGetModuleInfo )
		return FALSE;

	//set the return value
	*pPdbInfo = enumPdbInfoNotAvailable;

	IMAGEHLP_MODULE cMod;
	ZeroMemory( &cMod, sizeof( IMAGEHLP_MODULE ) );
	cMod.SizeOfStruct = sizeof( IMAGEHLP_MODULE );
	BOOL bRet = MySymGetModuleInfo( hProcess, dwAddr, &cMod );
	if ( !bRet )
	{
		return FALSE;
	}

	if ( cMod.SymType == SymPdb )
	{
		//get the timestamp of the pdb file 
		//the time stamp of the pdb file should  match the time stamp of the dll or exe

		//find the pdb with the same name in the same directory
		WIN32_FIND_DATA structFile;
		ZeroMemory( &structFile, sizeof( WIN32_FIND_DATA ) );
	
		//find the . in for example
		//c:\3.8\bin\ActiveIlx.exe
		//TCHAR * pDest = _tcschr( szFullModule, TCHAR('.') );
		TCHAR szExt[MAX_PATH];
		szExt[0] = NULL_CHAR;

		//#ifdef _UNICODE 
			_tsplitpath(szFullModule,0,0,0,szExt);
		//#else

		//#endif
			if ( szExt[0] == NULL_CHAR )
				return FALSE;

		//find the extension in the fullmodukle name
		TCHAR *pDest = _tcsstr( szFullModule, szExt );
		if ( !pDest )
			return FALSE;
		int nResult = pDest - szFullModule +1;
		if ( ( nResult > MAX_PATH - 4 ) || ( nResult < 0) ) //for .pdb
			return FALSE;
		//change the extension to .pdb
		_tcsncpy( szFullModule+nResult, EXT_PDB, sizeof( EXT_PDB ) );
		szFullModule[MAX_PATH-1] = NULL_CHAR;//null terminate the string
		//find the pdb file.
		HANDLE hFile = FindFirstFile( szFullModule, &structFile );
		if ( hFile == INVALID_HANDLE_VALUE )
		{
			return FALSE;
		}

		//close the file handle 
		FindClose( hFile );

		//convert the time to local time ( using day light saviongs etc )
		FILETIME	localFileTime;
		BOOL bRet = FileTimeToLocalFileTime( &(structFile.ftLastWriteTime), &localFileTime );
		if( !bRet )
		{
			return FALSE;
		}

		//convert from local to system time
		SYSTEMTIME datePdb;
		ZeroMemory( &datePdb, sizeof( SYSTEMTIME ) );
		bRet = FileTimeToSystemTime( &localFileTime, &datePdb );
		if ( !bRet )
		{
			return FALSE;
		}

		//get thge local time from the pdb timestamp
		struct tm *dateDll = localtime( reinterpret_cast<const long *>(&(cMod.TimeDateStamp)) );
		if ( !dateDll )
		{
			return FALSE;
		}

		//compare the two time stamps
		if ( ( dateDll->tm_year + YEAR_CORRECTION == datePdb.wYear ) && //include correction
			( dateDll->tm_mon + MONTH_CORRECTION == datePdb.wMonth )	&& //because 0 based
			( dateDll->tm_mday  == datePdb.wDay )	&&
			( dateDll->tm_hour == datePdb.wHour ) &&
			( dateDll->tm_min == datePdb.wMinute ) )
		{
			//cool the time stamp matches with the DLL 
			*pPdbInfo = enumPdbInfoSame; //
			return TRUE;
		}

		//Compare year of the pdb Vs Dll
		if ( datePdb.wYear > dateDll->tm_year + YEAR_CORRECTION )
		{
			//newer pdb than DLL
			*pPdbInfo = enumPdbInfoNewer; //
			return TRUE;
		}
		else if ( datePdb.wYear < dateDll->tm_year + YEAR_CORRECTION )
		{
			//older pdb than DLL
			*pPdbInfo = enumPdbInfoOlder; //
			return TRUE;
		}

		//Compare month of the pdb Vs Dll
		if ( datePdb.wMonth > dateDll->tm_mon + MONTH_CORRECTION)
		{
			//newer pdb than DLL
			*pPdbInfo = enumPdbInfoNewer; //
			return TRUE;
		}
		else if ( datePdb.wMonth < dateDll->tm_mon + MONTH_CORRECTION)
		{
			//older pdb than DLL
			*pPdbInfo = enumPdbInfoOlder; //
			return TRUE;
		}
		
		//Compare day of the pdb Vs Dll
		if ( datePdb.wDay > dateDll->tm_mday )
		{
			//newer pdb than DLL
			*pPdbInfo = enumPdbInfoNewer; //
			return TRUE;
		}
		else if ( datePdb.wDay < dateDll->tm_mday )
		{
			//older pdb than DLL
			*pPdbInfo = enumPdbInfoOlder; //
			return TRUE;
		}

		//Compare hour of the pdb Vs Dll
		if ( datePdb.wHour > dateDll->tm_hour )
		{
			//newer pdb than DLL
			*pPdbInfo = enumPdbInfoNewer; //
			return TRUE;
		}
		else if ( datePdb.wHour < dateDll->tm_hour )
		{
			//older pdb than DLL
			*pPdbInfo = enumPdbInfoOlder; //
			return TRUE;
		}

		//Compare minute of the pdb Vs Dll
		if ( datePdb.wMinute  > dateDll->tm_min )
		{
			//newer pdb than DLL
			*pPdbInfo = enumPdbInfoNewer; //
			return TRUE;
		}
		else if ( datePdb.wMinute < dateDll->tm_min )
		{
			//older pdb than DLL
			*pPdbInfo = enumPdbInfoOlder; //
			return TRUE;
		}
	}
	
	//we do not care 
	return TRUE;
}

//*********************************************************************
// FUNCTION		:	InternalSymGetLineFromAddr
//					
// DESCRIPTION	:	
//					Given a address this method will spit out
//					Exception file name & line number.
//					
// RETURNS		:	
//					BOOL - TRUE success FALSE failure.
//					
// PARAMETERS	:	
//					HANDLE hProcess:-[IN]
//					Handle to the current executing process.
//
//                  DWORD  dwAddr:-[IN]
//					Exception address.
//		
//					PDWORD pdwDisplacement:-[IN,OUT]
//					function displacement.
//					
//					PIMAGEHLP_LINE  Line:-[IN,OUT]
//					Symbol Information like Function name , Line Number .. etc.
//	
//					SYMGETLINEFROMADDRPROC	MySymGetLineFromAddr:-[IN]
//					ProcAddress for SymGetLineFromAddr				
// COMMENTS		:	
//					
//*********************************************************************

BOOL InternalSymGetLineFromAddr (  
	HANDLE					hProcess,
	DWORD					dwAddr,
	PDWORD					pdwDisplacement, 
	PIMAGEHLP_LINE			Line,          
	SYMGETLINEFROMADDRPROC	MySymGetLineFromAddr )
{
	//arg check
	if ( !MySymGetLineFromAddr || !Line )
	{
		return FALSE;
	}

    // The problem is that the symbol engine finds only those source
    // line addresses (after the first lookup) that fall exactly on
    // a zero displacement. I'll walk backward 100 bytes to
    // find the line and return the proper displacement.
    DWORD dwTempDis = 0 ;
    while ( FALSE == MySymGetLineFromAddr ( hProcess        ,
                                          dwAddr -
                                          dwTempDis      ,
                                          pdwDisplacement ,
                                          Line             ) )
    {
        dwTempDis += 1 ;
        if ( 100 == dwTempDis )
        {
            return ( FALSE ) ;
        }
    }

    // I found the line, and the source line information is correct, so
    // change the displacement if I had to search backward to find
    // the source line.
    if ( 0 != dwTempDis )
    {
        *pdwDisplacement = dwTempDis ;
    }

    return ( TRUE ) ;
}

//*********************************************************************
// FUNCTION		:	TruncatePath
//					
// DESCRIPTION	:	
//					Given a path retrievs the file name only.
//					for example for a input of c:\3.8\bin\ActiveILX.exe
//					this function would set szDest to ActiveILX.exe 
//					
// RETURNS		:	
//					none
//					
// PARAMETERS	:	
//					TCHAR * szSrc:-[IN]
//					Complete Path
//					TCHAR * szDest:-[IN/OUT]
//					Module or file Name	
// COMMENTS		:	
//					
//*********************************************************************

void TruncatePath( TCHAR* szSrc, TCHAR *szDest )
{
	//check arguments
	if ( !szSrc || !szDest )
		return;

	TCHAR * pDest = _tcschr( szSrc, TCHAR('\\') );
	int nResult  = 0;
	while ( pDest )
	{
		nResult = pDest - szSrc+1;
		pDest = _tcschr( szSrc+nResult, TCHAR('\\') );
	}

	//caution don't overwrite the buffer so adjust the length 
	_tcsncpy( szDest, szSrc+nResult, MAX_PATH - 1 - nResult - 1 ); //one for length other for nResult +1 

	//null terminate the resultant string
	szDest[MAX_PATH -1] = NULL_CHAR;
}

//*********************************************************************
// FUNCTION		:	GetLogicalAddress
//					
// DESCRIPTION	:	
//					This method returns the module name where the 
//					crash occurred. While walking the stack.
// RETURNS		:	
//					BOOL 
//					
// PARAMETERS	:	
//					PVOID addr:-[IN]
//					Address where crash ocurred while walking the stack
//					TCHAR* szModule:-[IN/OUT]
//					Module Name
//					DWORD len
//					Length of thr Module.+
// COMMENTS		:	
//					
//*********************************************************************
BOOL GetLogicalAddress( PVOID addr, TCHAR* szModule, DWORD len, TCHAR* szFullModuleName )
{
	if ( !szModule || !szFullModuleName )
		return FALSE;

    MEMORY_BASIC_INFORMATION mbi;

    if ( !VirtualQuery( addr, &mbi, sizeof(mbi) ) )
        return FALSE;

    DWORD hMod = (DWORD)mbi.AllocationBase;

	szFullModuleName[0] = NULL_CHAR;
    if ( !GetModuleFileName( (HMODULE)hMod, szFullModuleName, len ) )
        return FALSE;

	szFullModuleName[MAX_PATH-1] = NULL_CHAR; //null terminate the path string

	TruncatePath( szFullModuleName, szModule );//this will null terminate the szModule.

	return TRUE;
}

