///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/ILXLog/HelperFunctions.h,v 1.2 2004/09/07 06:06:04 me133 Exp $
//
//    File name:	HelperFunctions.h
//   Created By:	Marc Eaddy
//   Created On:	10/04/2000 4:16:13 PM
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: HelperFunctions.h,v $
 * Revision 1.2  2004/09/07 06:06:04  me133
 * o Now uses most recent ILXLog code with ILXCrashFinder
 * 
 * 
 * 13    8/30/02 9:14a Petert
 * Added email functionality
 * 
 * 12    7/24/02 2:49p Zakirh
 * o Log changes after CrashFinder API change memory is now in stack
 * rather than in heap.
 * 
 * 11    7/18/02 6:42p Zakirh
 * o change in format methods.
 * 
 * 10    7/18/02 2:53p Zakirh
 * o minor bug fixes.
 * 
 * 9     7/18/02 12:08a Zakirh
 * integration with crashfinder.
 * 
 * 6     2/12/01 12:13p Marce
 * o Moved GetHRESULTSeverity() into common helper functions
 * 
 * 4     11/07/00 5:26p Marce
 * o Added comments
 * 
 * 3     10/25/00 3:41p Marce
 * o Added GetSeverity()
 * 
 * 2     10/04/00 5:38p Marce
 * o Implemented log filtering
 */

#ifndef INCLUDED_HELPER_FUNCTIONS_H
#define INCLUDED_HELPER_FUNCTIONS_H

#include "CaseInsensitiveString.h"	// tstring

#include "ILXCrashFinder.h"

void ExtractFileAndSubsystem(	const TCHAR* szSubsystem,
								const TCHAR* szPath, 
								tstring* pstrFile, 
								tstring* pstrSubsystem);
	//
	// Extracts the file and subsystem from the szSubsystem and
	// szPath arguments.
	//
	// PARAMETERS:
	//
	//	szSubsystem - If NULL, the subsystem is retrieved from
	//		the path.  The first directory above the filename
	//		is used. Ex: "D:\ActiveILX\ILXLog\ILXLog.cpp" the
	//		filename is ILXLog.cpp and the subsystem is "ILXLog".
	//
	//	szPath - The full path of the file.  Cannot be NULL.
	//

const TCHAR* GetSeverity(long nSeverity);
	// Converts a ILXLOG_SEVERITIES severity enum into a string

long GetHRESULTSeverity(HRESULT hr);

HRESULT GetILXDirectoryFromRegistry(const TCHAR* szDirectoryName,
									wchar_t* szDirectory,
									long nMaxLen);

BOOL FormatStackString1( PILXStackFrame pStackFrame, TCHAR *stString, const long lLength );
BOOL FormatStackString2( PILXStackFrame pStackFrame, TCHAR *stString, const long lLength );

#endif // INCLUDED_HELPER_FUNCTIONS_H
