///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/ILXLog/ILXLogMain.cpp,v 1.2 2004/09/07 06:06:04 me133 Exp $
//
//    File name:	ILXLogMain.cpp
//   Created By:	Marc Eaddy
//   Created on:	04/24/2000 11:25:31 AM
//
//      Purpose:	Implementation of DLL Exports	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: ILXLogMain.cpp,v $
 * Revision 1.2  2004/09/07 06:06:04  me133
 * o Now uses most recent ILXLog code with ILXCrashFinder
 * 
 * 
 * 4     5/01/00 10:22a Marce
 * o Removed ILXLogHelper from DLL since it does not need to be there.  It
 * is shared via source code only.
 * 
 * 3     4/24/00 2:10p Marce
 * o Moved CLSID initialization to LogHelper compilation unit to make it
 * easier to share LogHelper
 * 
 * 2     4/24/00 11:47a Marce
 * 
 * 1     4/24/00 11:27a Marce
 */

// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f ILXLogps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "ILXLog2.h"

#include "ILXLog_i.c"		// IIDs and CLSIDs

#include "ILXLogImpl.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_ILXLog, CILXLog)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance, &LIBID_ILXLOGLib);
        DisableThreadLibraryCalls(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
        _Module.Term();
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}


