///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/ILXLog/LogDestination.cpp,v 1.2 2004/09/07 06:06:05 me133 Exp $
//
//    File name:	LogDestination.cpp
//   Created By:	Marc Eaddy
//   Created On:	10/03/2000 1:27:17 PM
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: LogDestination.cpp,v $
 * Revision 1.2  2004/09/07 06:06:05  me133
 * o Now uses most recent ILXLog code with ILXCrashFinder
 * 
 * 
 * 4     10/05/00 1:35p Marce
 * o Now provides a default implementation of initialize()
 * 
 * 3     10/04/00 5:38p Marce
 * o Implemented log filtering
 * 
 * 2     10/03/00 6:33p Marce
 * o Added log configuration classes
 */

#include "StdAfx.h"

#include "LogDestination.h"	// Me

///////////////////////////////////
// LOG DESTINATION IMPLEMENTATION
///////////////////////////////////

CLogDestination::CLogDestination(const TCHAR* szSubType)
	: CXmlElement(_T("DEST"), _T(""), szSubType)
	, m_bIsInitialized(false)
{ }

CLogDestination::~CLogDestination()
{ }

HRESULT CLogDestination::initialize()
{
	HRESULT hr = S_OK;

	// Invariants: Only call initialize() once
	_ASSERTE(!m_bIsInitialized);

	m_bIsInitialized = true;

	// Post-conditions
	_ASSERTE(m_bIsInitialized);

	return S_OK;
}

bool CLogDestination::isInitialized() const
{
	return m_bIsInitialized;
}
