///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/ILXLog/StdOutDestination.h,v 1.3 2004/09/23 05:51:13 me133 Exp $
//
//    File name:	StdOutDestination.h
//   Created By:	Marc Eaddy
//   Created On:	10/04/2000 2:27:28 PM
//
//      Purpose:	Outputs the log message to the standard output console window.
//
//  Description:	
//
//   Xml Format:	<DEST TYPE="StdOut"/>
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: StdOutDestination.h,v $
 * Revision 1.3  2004/09/23 05:51:13  me133
 * o Now prints INFO and SUCCESS messages
 * o Now supports verbose output
 *
 * Revision 1.2  2004/09/07 06:06:05  me133
 * o Now uses most recent ILXLog code with ILXCrashFinder
 * 
 * 
 * 5     7/17/02 3:10p Marce
 * o Added preliminary support for passing exception info via the
 * SIlxStackFrame structure used by IlxCrashFinder
 * 
 * 2     5/01/01 4:10p Marce
 * o Added StdOut destination
 */

#ifndef INCLUDED_STD_OUT_DESTINATION_H
#define INCLUDED_STD_OUT_DESTINATION_H

#include "LogDestination.h"	// Parent

//*****************************
// CStdOutDestination
//*****************************

class CStdOutDestination : public CLogDestination
{
public:

	CStdOutDestination(bool bVerbose);
	virtual ~CStdOutDestination();

public:

	virtual HRESULT log(	const TCHAR* szSubsystem, 
							const TCHAR* szPath,
							const TCHAR* szFilename, 
							long nLine, 
							long nThreadId, 
							long hrErrorCode,
							SIlxStackFrames* pvIlxStackFrames,
							long nNumStackFrames,
							const TCHAR* szMessage, 
							long nSeverity);
		//
		// See LogDestination.h for a description.
		//

protected:
	// Overrides CXmlElement
	virtual CXmlElement* clone() const;
		//
		// Clones this element.
		//

private: // NOT IMPLEMENTED

	CStdOutDestination(const CStdOutDestination&);
	CStdOutDestination& operator=(const CStdOutDestination&);

private: // DATA
	bool m_bVerbose;
};

#endif // INCLUDED_STD_OUT_DESTINATION_H