#ifndef INCLUDED_ILX_NULL_LOG_H
#define INCLUDED_ILX_NULL_LOG_H

// Log a message that has an associated HRESULT

#define ILXLOG(hr, msg, severity) \
	hr

#define ILXLOG0(hr, severity, msg) \
	hr

#define ILXLOG1(hr, severity, msg, arg1) \
	hr

#define ILXLOG2(hr, severity, msg, arg1, arg2) \
	hr

#define ILXLOG3(hr, severity, msg, arg1, arg2, arg3) \
	hr

#define ILXLOG4(hr, severity, msg, arg1, arg2, arg3, arg4) \
	hr

#define ILXLOG5(hr, severity, msg, arg1, arg2, arg3, arg4, arg5) \
	hr

// Log a message that doesn't have an associated HRESULT

#define ILXLOGMSG(msg, severity) \
	{																				\
		AtlTrace(msg);	\
	}

#define ILXLOGMSG0(severity, msg) \
	{																				\
		AtlTrace(msg);	\
	}

#define ILXLOGMSG1(severity, msg, arg1) \
	{																				\
		AtlTrace(msg, arg1);	\
	}

#define ILXLOGMSG2(severity, msg, arg1, arg2) \
	{																				\
		AtlTrace(msg, arg1, arg2);	\
	}

#define ILXLOGMSG3(severity, msg, arg1, arg2, arg3) \
	{																				\
		AtlTrace(msg, arg1, arg2, arg3);	\
	}

#define ILXLOGMSG4(severity, msg, arg1, arg2, arg3, arg4) \
	{																				\
		AtlTrace(msg, arg1, arg2, arg3, arg4);	\
	}

#define ILXLOGMSG5(severity, msg, arg1, arg2, arg3, arg4, arg5) \
	{																				\
		AtlTrace(msg, arg1, arg2, arg3, arg4, arg5);	\
	}

// Display message in a modal dialog box (in a separate thread)

#define ILXMSGBOX(hr)																\
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
	}

#define ILXMSGBOX0(severity, msg) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg);											\
	}

#define ILXMSGBOX1(severity, msg, arg1) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg, arg1);									\
	}

#define ILXMSGBOX2(severity, msg, arg1, arg2) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg, arg1, arg2);								\
	}

#define ILXMSGBOX3(severity, msg, arg1, arg2, arg3) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg, arg1, arg2, arg3);						\
	}

#define ILXMSGBOX4(severity, msg, arg1, arg2, arg3, arg4) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg, arg1, arg2, arg3, arg4);					\
	}

#define ILXMSGBOX5(severity, msg, arg1, arg2, arg3, arg4, arg5) \
	{																				\
		_ASSERTE(!"ILXLog Message Box has been disabled");      \
 		AtlTrace(_T("ILXLog Message Box has been disabled"));	\
		AtlTrace(msg, arg1, arg2, arg3, arg4, arg5);			\
	}

// Macros for checking HRESULT return codes

#define VERIFY_HR(hr, msg, severity)												\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR0(hr, severity, msg)												\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR1(hr, severity, msg, arg1)											\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR2(hr, severity, msg, arg1, arg2)									\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR3(hr, severity, msg, arg1, arg2, arg3)								\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR4(hr, severity, msg, arg1, arg2, arg3, arg4)						\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR5(hr, severity, msg, arg1, arg2, arg3, arg4, arg5)					\
	if (FAILED(hr)) {																\
		return hr; \
	}

#define VERIFY_HR_ASSERT(hr, msg, severity)											\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

#define VERIFY_HR_ASSERT1(hr, severity, msg, arg1)									\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

#define VERIFY_HR_ASSERT2(hr, severity, msg, arg1, arg2)							\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

#define VERIFY_HR_ASSERT3(hr, severity, msg, arg1, arg2, arg3)						\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

#define VERIFY_HR_ASSERT4(hr, severity, msg, arg1, arg2, arg3, arg4)				\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

#define VERIFY_HR_ASSERT5(hr, severity, msg, arg1, arg2, arg3, arg4, arg5)			\
	if (FAILED(hr))																	\
	{																				\
		_ASSERTE(!msg);																\
		return hr; \
	}										

// Macro for checking a boolean condition

#define VERIFY_COND(cond, msg, severity)											\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND0(cond, severity, msg)											\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND1(cond, severity, msg, arg1)										\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND2(cond, severity, msg, arg1, arg2)								\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND3(cond, severity, msg, arg1, arg2, arg3)							\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND4(cond, severity, msg, arg1, arg2, arg3, arg4)					\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

#define VERIFY_COND5(cond, severity, msg, arg1, arg2, arg3, arg4, arg5)				\
	if (!(cond))																	\
	{																				\
		return E_FAIL;															\
	}

// Macros for checking an HRESULT and a boolean condition

#define VERIFY_HR_COND(hr, cond, msg, severity)										\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND0(hr, cond, severity, msg)									\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND1(hr, cond, severity, msg, arg1)								\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND2(hr, cond, severity, msg, arg1, arg2)						\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND3(hr, cond, severity, msg, arg1, arg2, arg3)					\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND4(hr, cond, severity, msg, arg1, arg2, arg3, arg4)			\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#define VERIFY_HR_COND5(hr, cond, severity, msg, arg1, arg2, arg3, arg4, arg5)		\
	if (FAILED(hr) || !(cond))														\
	{																				\
		HRESULT hr2 = FAILED(hr) ? hr : E_FAIL;									\
		return hr2;				\
	}										

#endif // INCLUDED_ILX_NULL_LOG_H
