///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/XmlElement.cpp,v 1.3 2004/09/07 06:08:57 me133 Exp $
//
//    File name:	XmlElement.cpp
//   Created By:	Marc Eaddy
//   Created on:	03/08/2000 11:11:50 AM
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: XmlElement.cpp,v $
 * Revision 1.3  2004/09/07 06:08:57  me133
 * o Second checkin to CVS
 * 
 * 
 * 59    6/18/02 11:12a Marce
 * o Fixed compile error hwne DONT_USE_ILX_LOG was defined
 * 
 * 58    6/17/02 7:43p Marce
 * o No longer treats file not found as an error.  The caller must
 * interpret this as an error.
 * 
 * 57    3/18/02 9:15p Marce
 * o Now saves XML whitespace correctly
 * o Now includes the date in the XML comments
 * 
 * 55    1/04/02 10:32a Marce
 * Fixed compile errors
 * 
 * 54    1/03/02 1:32p Marce
 * o Minor change
 * 
 * 53    1/03/02 12:28p Marce
 * o Added date to xml file comment
 * 
 * 52    11/15/01 3:52p Marce
 * o Was not saving any group nodes
 * 
 * 51    11/15/01 12:44p Marce
 * o Now propagates S_FALSE when save() returns it
 * o Now doesn't save an empty line if we don't save a child element
 * 
 * 50    11/12/01 12:27p Marce
 * o Implemented "nopersist" attribute 
 * 
 * 49    11/02/01 6:30p Marce
 * o Now if you specify 0 or "" for setSourceFile() the attribute will be
 * deleted
 * 
 * 48    11/02/01 5:17p Zakirh
 * added removeSourceFile
 * 
 * 47    11/02/01 1:02p Marce
 * o Moved constants back into source file because they are causing
 * ILXCommon to not compile
 * o Added getSourceFile() and setSourceFile()
 * 
 * 43    10/30/01 12:06p Marce
 * o Fixed compile bug
 * o Changed method signature to avoid extra memory allocation and
 * copying, and to allow you to specify any variant as a value not just a
 * string
 * 
 * 42    10/30/01 11:39a Zakirh
 * added setAttribute
 * 
 * 41    10/25/01 10:12p Marce
 * o Added an XML file comment
 * 
 * 40    10/25/01 9:47p Marce
 * o Added success log messages
 * 
 * 39    10/25/01 9:34p Marce
 * o Now overwrites the SRC file when saving
 * o Now creates a new XML document if needed when saving
 * 
 * 38    10/23/01 6:20p Marce
 * o Changed name from loadFromSource() to loadChildren() for clarity
 * 
 * 37    10/23/01 6:04p Marce
 * o Added support for specifiying a separate file to hold child elements
 * using the SRC attribute
 * 
 * 36    10/22/01 2:35p Marce
 * o Broke out functionality so it can be overridden.  Added loadChild(),
 * afterLoad(), and beforeSave().
 * o Made some data members protected
 * 
 * 35    10/22/01 12:35p Marce
 * o One version of load() doesn't have to be virtual since it calls the
 * other version
 * o Added afterLoad() virtual method
 * 
 * 34    10/19/01 7:22p Marce
 * o Fixed compile error
 * 
 * 33    10/19/01 7:18p Marce
 * o Now allows you to load a file or a node
 * 
 * 32    10/19/01 4:42p Marce
 * o Added getElementName()
 * 
 * 31    9/24/01 5:44p Laijunx
 * add highlight button logic
 * 
 * 30    9/24/01 12:25p Marce
 * o Changed to isMyChild() for clarity
 * 
 * 29    9/24/01 12:22p Marce
 * o Added isChild()
 * 
 * 28    8/17/01 3:17p Marce
 * o Now saved XML looks much better
 * 
 * 27    8/16/01 7:15p Marce
 * o Added ability to get any attribute
 * 
 * 25    7/19/01 2:33p Marce
 * o Added ability to delete and reparent children
 * o insertChild() defaults to append the child
 * 
 * 24    7/19/01 1:53p Marce
 * o Added delete and reparent
 * 
 * 23    7/17/01 6:56p Marce
 * o Now compiles in isolation
 * 
 * 22    7/16/01 5:28p Marce
 * o clear() should clear the attributes as well
 * 
 * 21    7/16/01 5:27p Marce
 * o Added clear() method
 * 
 * 20    7/03/01 7:57p Marce
 * o Now a child can get its parent
 * o Fixed order of member initialization in constructor
 * 
 * 19    7/03/01 6:24p Marce
 * o Now implements save()
 * o Now allows you to specify a factory creation function instead of
 * using prototypes.  This is necessary if the class's constructor calls
 * addPrototype() with the same name as the class which results in an
 * infinite recursion.
 * 
 * 18    5/01/01 4:10p Marce
 * o Improved log message
 * 
 * 17    4/09/01 12:20p Marce
 * o Now checks for S_OK instead of just FAILED(hr)
 * 
 * 16    1/30/01 10:51a Marce
 * o Fixed compile errors for Debug build
 * 
 * 15    12/01/00 6:46p Marce
 * o Added ctor
 * 
 * 14    11/10/00 12:49p Marce
 * o Minor changes
 * 
 * 12    10/04/00 5:36p Marce
 * o Provided a check to prevent multiple load() calls which are usually
 * not expected
 * 
 * 11    10/03/00 8:07p Marce
 * o Now provides access to subtype
 * 
 * 10    10/03/00 6:36p Marce
 * o Added support for using the NAME attribute to specify subclasses
 * 
 * 9     5/11/00 10:22p Marce
 * o Fixed another memory leak!
 * 
 * 8     5/11/00 10:21p Marce
 * o Fixed a memory leak
 * 
 * 6     5/01/00 3:11p Marce
 * o Added log messages
 * 
 * 5     5/01/00 10:22a Marce
 * o Now logs unrecognized elements
 * 
 * 4     3/08/00 1:35p Marce
 * o Now all class uses a common base class that implements XML
 * persistence
 * 
 * 2     3/08/00 12:09p Marce
 */

#include "StdAfx.h"

#include "XmlElement.h"		// Me

#include "XmlHelpers2.h"	// LoadAttributesFromXML()

#ifndef DONT_USE_ILX_LOG
#include "XmlLogHelper.h"	// LogXmlError()
#include "ILXLogHelper.h"	// Logging singleton
#else
#include "IlxNullLogHelper.h"
#endif // DONT_USE_ILX_LOG

#ifndef INCLUDED_MSXML_TYPE_LIBRARY
#define INCLUDED_MSXML_TYPE_LIBRARY
#import "msxml.dll" rename_namespace("MSXML"), named_guids, raw_interfaces_only, raw_native_types
#endif // INCLUDED_MSXML_TYPE_LIBRARY

#include <time.h>			// time(), localtime()

using namespace MSXML;

// Constants
static CComBSTR bstrTYPE_ATTR			= _T("TYPE");
static const tstring strSRC_ATTR		= _T("SRC");
static const TCHAR* const szNAME_ATTR	= _T("NAME");

/////////////////////////////////
// XML PERSISTED IMPLEMENTATION
/////////////////////////////////

CXmlElement::CXmlElement(	const TCHAR* szXmlTagName,
							const TCHAR* szXmlTagName2,
							const TCHAR* szSubType,
							bool bAllowMultipleLoads,
							bool bValidateXmlTagOnLoad)
	: m_strXmlTagName(szXmlTagName)
	, m_pParent(0)
	, m_mapAttributes()
	, m_vecChildren()
	, m_strXmlTagName2(szXmlTagName2)
	, m_strSubType(szSubType)
	, m_vecChildPrototypes()
	, m_bAllowMultipleLoads(bAllowMultipleLoads)
	, m_bIsLoaded(false)
	, m_bValidateXmlTagOnLoad(bValidateXmlTagOnLoad)
	, m_pfnFactoryMethod(0)
{ }

CXmlElement::CXmlElement(	const TCHAR* szXmlTagName,
							bool bAllowMultipleLoads)
	: m_strXmlTagName(szXmlTagName)
	, m_pParent(0)
	, m_mapAttributes()
	, m_vecChildren()
	, m_strXmlTagName2(_T(""))
	, m_strSubType(_T(""))
	, m_vecChildPrototypes()
	, m_bAllowMultipleLoads(bAllowMultipleLoads)
	, m_bIsLoaded(false)
	, m_bValidateXmlTagOnLoad(true)
	, m_pfnFactoryMethod(0)
{ }

CXmlElement::CXmlElement(const CXmlElement& that)
	: m_strXmlTagName(that.m_strXmlTagName)
	, m_pParent(that.m_pParent)
	, m_mapAttributes(that.m_mapAttributes)
	, m_vecChildren()
	, m_strXmlTagName2(that.m_strXmlTagName2)
	, m_strSubType(that.m_strSubType)
	, m_vecChildPrototypes()
	, m_bAllowMultipleLoads(that.m_bAllowMultipleLoads)
	, m_bIsLoaded(that.m_bIsLoaded)
	, m_bValidateXmlTagOnLoad(that.m_bValidateXmlTagOnLoad)
	, m_pfnFactoryMethod(that.m_pfnFactoryMethod)
{ 
	copyChildrenAndPrototypes(that);
}

CXmlElement& CXmlElement::operator=(const CXmlElement& that)
{ 
	if (this != &that)
	{
		m_strXmlTagName			= that.m_strXmlTagName;
		m_pParent				= that.m_pParent;
		m_mapAttributes			= that.m_mapAttributes;
		m_strXmlTagName2		= that.m_strXmlTagName2;
		m_strSubType			= that.m_strSubType;
		m_bAllowMultipleLoads	= that.m_bAllowMultipleLoads;
		m_bIsLoaded				= that.m_bIsLoaded;
		m_bValidateXmlTagOnLoad	= that.m_bValidateXmlTagOnLoad;
		m_pfnFactoryMethod		= that.m_pfnFactoryMethod;

		copyChildrenAndPrototypes(that);
	}

	return *this;
}

CXmlElement::~CXmlElement()
{ 
	removeChildren();
	removePrototypes();
}

//--------------------------------------------------------------
//                      Children methods
//--------------------------------------------------------------

CXmlElement* CXmlElement::insertChild(CXmlElement* pElement, int nIndex)
{
	HRESULT hr = S_OK;

	// Pre-conditons
	_ASSERTE(pElement);

	if (nIndex == -1)
	{
		nIndex = m_vecChildren.size();
	}

	TypeVecXmlElementPtrs::iterator it_new =
		m_vecChildren.insert(m_vecChildren.begin() + nIndex, pElement);

	pElement->m_pParent = this;

	return *it_new;
}

void CXmlElement::deleteChild(int nIndex)
{
	TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin() + nIndex;

	CXmlElement*& pElementToDelete = *it;
	delete pElementToDelete;
	pElementToDelete = 0;

	m_vecChildren.erase(it);
}

void CXmlElement::deleteChild(CXmlElement* pChild)
{
	for(TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin();
		it != m_vecChildren.end();
		++it)
	{
		CXmlElement*& pElement = *it;
		if (pElement == pChild)
		{
			delete pElement;
			pElement = 0;

			m_vecChildren.erase(it);
			return;
		}
	}

	_ASSERTE(!"Child not found");
}

void CXmlElement::reparentChild(int nIndex, CXmlElement* pNewParent, int nNewIndex)
{
	TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin() + nIndex;

	CXmlElement*& pElementToDelete = *it;

	m_vecChildren.erase(it);

	pNewParent->insertChild(pElementToDelete, nNewIndex);
}

void CXmlElement::reparentChild(CXmlElement* pChild, CXmlElement* pNewParent, int nNewIndex)
{
	for(TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin();
		it != m_vecChildren.end();
		++it)
	{
		CXmlElement*& pElement = *it;
		if (pElement == pChild)
		{
			m_vecChildren.erase(it);

			pNewParent->insertChild(pChild, nNewIndex);

			return;
		}
	}

	_ASSERTE(!"Child not found");
}

TypeVecXmlElementPtrs& CXmlElement::getChildren()
{
	return m_vecChildren;
}

const TypeVecXmlElementPtrs& CXmlElement::getChildren() const
{
	return m_vecChildren;
}

const CXmlElement* CXmlElement::getChild(int nIndex) const
{
	if (nIndex >= 0 && nIndex < (int) m_vecChildren.size())
	{
		return m_vecChildren.at(nIndex);
	}
	else
	{
		return 0;
	}
}

CXmlElement* CXmlElement::getChild(int nIndex)
{
	if (nIndex >= 0 && nIndex < (int) m_vecChildren.size())
	{
		return m_vecChildren.at(nIndex);
	}
	else
	{
		return 0;
	}
}

const CXmlElement* CXmlElement::getParent() const
{
	return m_pParent;
}

CXmlElement* CXmlElement::getParent()
{
	return m_pParent;
}

long CXmlElement::getNumChildren() const
{
	return m_vecChildren.size();
}

void CXmlElement::clear()
{
	removeChildren();
	m_bIsLoaded = false;
	m_mapAttributes.clear();
}

void CXmlElement::setSourceFile(const TCHAR* szFilePath)
{
	if (!szFilePath || !*szFilePath)
	{
		m_mapAttributes.erase(strSRC_ATTR);
	}
	else
	{
		m_mapAttributes[strSRC_ATTR] = szFilePath;
	}
}

const TCHAR* CXmlElement::getSourceFile() const
{
	const _variant_t& varSource = getAttribute(strSRC_ATTR);
	if (varSource.vt != VT_BSTR || !varSource.bstrVal)
	{
		return _T("");
	}
	else
	{
		return (const TCHAR*) varSource.bstrVal;// Very bad!
	}
}

//--------------------------------------------------------------
//                      Factory methods
//--------------------------------------------------------------

void CXmlElement::setFactoryMethod(PFN_FACTORY_METHOD pfnFactoryMethod)
{
	m_pfnFactoryMethod = pfnFactoryMethod;
}

void CXmlElement::addChildPrototype(const CXmlElement* pElement)
{
	m_vecChildPrototypes.push_back(pElement);
}

CXmlElement* CXmlElement::clone() const
{
	_ASSERTE(!_T("Should be overridden by the subclass!"));
	return new CXmlElement(*this);
}

CXmlElement* CXmlElement::createNew(const TCHAR* szXmlElementName,
									const CComVariant& varAttributeValue) const
{
	if (m_pfnFactoryMethod)
	{
		return m_pfnFactoryMethod(*this, szXmlElementName, varAttributeValue);
	}

	USES_CONVERSION;

	for(TypeVecXmlElementCPtrs::const_iterator it = m_vecChildPrototypes.begin();
		it != m_vecChildPrototypes.end();
		++it)
	{
		const CXmlElement* pElement = *it;
		_ASSERTE(pElement);
		
		// See if the XML tag matches
		if (_tcsicmp(pElement->m_strXmlTagName.c_str(), szXmlElementName) == 0 ||
			_tcsicmp(pElement->m_strXmlTagName2.c_str(), szXmlElementName) == 0)
		{
			// See if the XML attribute matches
			if (pElement->m_strSubType.length() > 0 && 
				varAttributeValue.vt == VT_BSTR &&
				varAttributeValue.bstrVal &&
				_tcsicmp(pElement->m_strSubType.c_str(), OLE2CT(varAttributeValue.bstrVal)) != 0)
			{
				continue;
			}

			return pElement->clone();
		}
	}

	return 0;
}

void CXmlElement::copyChildrenAndPrototypes(const CXmlElement& that)
{
	removeChildren();
	removePrototypes();

	for(TypeVecXmlElementPtrs::const_iterator it = that.m_vecChildren.begin();
		it != that.m_vecChildren.end();
		++it)
	{
		const CXmlElement* pChildToCopy = *it;
		_ASSERTE(pChildToCopy);

		insertChild(pChildToCopy->clone());
	}

	for(TypeVecXmlElementCPtrs::const_iterator it2 = that.m_vecChildPrototypes.begin();
		it2 != that.m_vecChildPrototypes.end();
		++it2)
	{
		const CXmlElement* pElement = *it2;
		_ASSERTE(pElement);

		m_vecChildPrototypes.push_back(pElement->clone());
	}
}

void CXmlElement::removeChildren()
{
	for(TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin();
		it != m_vecChildren.end();
		++it)
	{
		CXmlElement*& pElement = *it;
		_ASSERTE(pElement);

		delete pElement;
		pElement = 0;
	}

	m_vecChildren.clear();
}

void CXmlElement::removePrototypes()
{
	for(TypeVecXmlElementCPtrs::iterator it2 = m_vecChildPrototypes.begin();
		it2 != m_vecChildPrototypes.end();
		++it2)
	{
		const CXmlElement*& pElement = *it2;
		_ASSERTE(pElement);

		delete pElement;
		pElement = 0;
	}

	m_vecChildPrototypes.clear();
}

bool CXmlElement::isMyChild(CXmlElement* pXmlElement) const
{
	for(TypeVecXmlElementPtrs::const_iterator it = getChildren().begin();
		it != getChildren().end();
		++it)
	{
		const CXmlElement* pChild = *it;
		_ASSERTE(pChild);

		if (pChild == pXmlElement) return true;

		bool bIsChild = pChild->isMyChild(pXmlElement);
		if (bIsChild) return true;
	}

	return false;
}

//--------------------------------------------------------------
//                      Persistence methods
//--------------------------------------------------------------

HRESULT CXmlElement::load(VARIANT varFileNameOrNode)
{
	HRESULT hr = S_OK;

	CComPtr<MSXML::IXMLDOMNode> spiXmlNode;

	hr = ::GetXmlNodeFromVariant(varFileNameOrNode, &spiXmlNode);
	if (FAILED(hr)) return hr;

	_ASSERTE(spiXmlNode);
	if (!spiXmlNode) return E_UNEXPECTED;

	hr = load(spiXmlNode);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to load '%s' XML elements."),
		m_strXmlTagName.c_str());

	if (varFileNameOrNode.vt == VT_BSTR && 
		varFileNameOrNode.bstrVal)
	{
		ILXLOGMSG2(ILXLOG_SUCCESS, _T("Loaded '%s' XML elements from '%s'."),
			m_strXmlTagName.c_str(),
			varFileNameOrNode.bstrVal);
	}

	return S_OK;
}

//*********************************************************************
// FUNCTION		:	CXmlElement::load
// 
// DESCRIPTION	:	Initializes the persisted element using an XML node.
// 
// RETURNS		:	
//   HRESULT 		
// 
// PARAMETERS	:	
//   spiNode	
//
// COMMENTS		:	
//
//*********************************************************************
HRESULT CXmlElement::load(MSXML::IXMLDOMNode* piNode)
{
	HRESULT hr = S_OK;

	USES_CONVERSION;

	// Pre-conditions
	VERIFY_COND(piNode, _T("Invalid argument."), ILXLOG_ERROR);
	VERIFY_COND(!m_bIsLoaded || m_bAllowMultipleLoads,
		_T("Not allowed to call load() twice on same object."), ILXLOG_ERROR);

	// Pre-condition

	bool bXmlTagMatches = false;

	CComBSTR bstrElementName;

	hr = piNode->get_nodeName(&bstrElementName);
	if (hr != S_OK || !bstrElementName)
	{
		hr = FAILED(hr) ? hr : E_FAIL;
		ILXLOG(hr, _T("Failed to retrieve the node name."), ILXLOG_ERROR);
		_ASSERTE(false);
	}

	if (bstrElementName.Length() > 0 &&
		_tcsicmp(OLE2CT(bstrElementName), m_strXmlTagName.c_str()) == 0 ||
		_tcsicmp(OLE2CT(bstrElementName), m_strXmlTagName2.c_str()) == 0)
	{
		bXmlTagMatches = true;
	}
	else
	{
		bXmlTagMatches = false;
	}

	if (!bXmlTagMatches && m_bValidateXmlTagOnLoad)
	{
		ILXLOGMSG1(	ILXLOG_ERROR,
					_T("CXmlElement::load() error - Attempted to initialize a ")
					_T("CXmlElement subclass using an incompatible XML node: '%ls'."),
					bstrElementName);
		_ASSERTE(false);
		return E_UNEXPECTED;
	}

	if (bXmlTagMatches)
	{
		// Step 1:	Load the attributes

		hr = LoadAttributesFromXML(piNode, &m_mapAttributes);
		VERIFY_HR(hr, _T("Failed to load the node attributes."), ILXLOG_ERROR);

		hr = afterLoadAttributes();
		VERIFY_HR(hr, _T("afterLoadAttributes() failed."), ILXLOG_ERROR);
	}

	// Step 2:	Load the child elements

	const _variant_t& varSrc = getAttribute(strSRC_ATTR);
	if (varSrc.vt == VT_BSTR && varSrc.bstrVal && *varSrc.bstrVal)
	{
		hr = loadChildren(OLE2CT(varSrc.bstrVal));
		VERIFY_HR1(hr, ILXLOG_ERROR, _T("loadFromSource() failed for '%s'."), 
			varSrc.bstrVal);
	}
	else
	{
		hr = loadChildren(piNode);
		VERIFY_HR(hr, _T("Failed to load children."), ILXLOG_ERROR);
	}

	m_bIsLoaded = true;

	hr = afterLoad();
	VERIFY_HR(hr, _T("afterLoad() failed."), ILXLOG_ERROR);

	return S_OK;
}

HRESULT CXmlElement::loadChildren(const TCHAR* szFilePath)
{
	if (!szFilePath || !*szFilePath) return E_POINTER;

	HRESULT hr = S_OK;

	CComPtr<MSXML::IXMLDOMNode> spiNode;

	hr = GetXmlNodeFromVariant(	CComVariant(szFilePath), &spiNode);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to load XML file from '%ls'."), 
		szFilePath);

	hr = loadChildren(spiNode);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to load XML children from '%ls'."), 
		szFilePath);

	ILXLOGMSG2(ILXLOG_SUCCESS, _T("Loaded '%s' XML elements from '%s'."),
		m_strXmlTagName.c_str(),
		szFilePath);

	return S_OK;
}

HRESULT CXmlElement::loadChildren(MSXML::IXMLDOMNode* piParentNode)
{
	HRESULT hr = S_OK;

	if (!piParentNode) return E_POINTER;

	// Step 1:	Get the list of children

	CComPtr<MSXML::IXMLDOMNodeList> spiChildNodeList;
	
	hr = piParentNode->get_childNodes(&spiChildNodeList);
	VERIFY_HR_COND(hr, hr == S_OK && spiChildNodeList != 0,
		_T("Failed to get the child nodes."), ILXLOG_ERROR);

	// Step 2:	Get the number of children in the list

	long nChildListLength = 0;
	
	hr = spiChildNodeList->get_length(&nChildListLength);
	VERIFY_HR_COND(hr, hr == S_OK, _T("Failed to get the number of children."), 
		ILXLOG_ERROR);

	// Step 3:	Load each XML child node

	for(int i=0; i < nChildListLength; ++i)
	{
		// Step 4:	Get the child node
		CComPtr<MSXML::IXMLDOMNode> spiChildNode;

		hr = spiChildNodeList->get_item(i, &spiChildNode);
		if (hr != S_OK || spiChildNode == 0)
		{
			ILXLOG(hr, _T("Failed to retrieve XML node."), ILXLOG_ERROR);
			_ASSERTE(false);
			continue;
		}

		// Step 5:	Get the node type
		MSXML::DOMNodeType typeNode = (MSXML::DOMNodeType) MSXML::NODE_INVALID;
		hr = spiChildNode->get_nodeType(&typeNode);
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to retrieve node type."), ILXLOG_ERROR);
			_ASSERTE(false);
			continue;
		}
		
		// Ignore non-ELEMENT nodes (e.g., comments or whitespace)
		if (typeNode != MSXML::NODE_ELEMENT)
		{
			continue;
		}

		// Step 6:	Load the child

		hr = loadChild(spiChildNode);
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to load XML child."), ILXLOG_ERROR);
		}
	}

	return S_OK;
}

HRESULT CXmlElement::loadChild(MSXML::IXMLDOMNode* piChildNode)
{
	USES_CONVERSION;

	HRESULT hr = S_OK;

	// Verify parameters
	if (!piChildNode) return E_POINTER;

	// Get the tag name

	CComBSTR bstrNodeName;
	hr = piChildNode->get_nodeName(&bstrNodeName);
	VERIFY_HR_COND(hr, hr == S_OK && bstrNodeName, _T("Failed to retrieve node name."), 
		ILXLOG_ERROR);

	CComQIPtr<MSXML::IXMLDOMElement> spiChildElement(piChildNode);
	VERIFY_COND(spiChildElement, _T("Failed to QI for IXMLDOMElement."), 
		ILXLOG_ERROR);

	CComVariant varTypeAttr;
	hr = spiChildElement->getAttribute(bstrTYPE_ATTR, &varTypeAttr);
	VERIFY_HR(hr, _T("Failed to retrieve name attribute."), ILXLOG_ERROR);

	// Create the layout using the createNew() Abstract Factory

	CXmlElement* pChildElement = createNew(OLE2CT(bstrNodeName), varTypeAttr);
	VERIFY_COND2(pChildElement, ILXLOG_WARNING, 
			_T("Unknown XML layout element encountered: '%ls'-'%ls'."), 
			bstrNodeName,
			varTypeAttr.vt == VT_BSTR && varTypeAttr.bstrVal ? varTypeAttr.bstrVal : L"<NO SUBTYPE>");

	// Initialize the child's parent now so that its available during load()
	pChildElement->m_pParent = this;

	// Initialize the new layout element using the XML child node

	hr = pChildElement->load(piChildNode);
	if (FAILED(hr)) 
	{
		delete pChildElement;
		pChildElement = 0;
		return ILXLOG(hr, _T("Failed to load child element."), ILXLOG_ERROR);
	}

	// Append the new child to our collection of children

	insertChild(pChildElement);

	return S_OK;
}

HRESULT CXmlElement::afterLoadAttributes()
{
	return S_OK;
}

HRESULT CXmlElement::afterLoad()
{ 
	return S_OK;
}

HRESULT CXmlElement::save(VARIANT varFileNameOrXmlNode, long nIndentLevel)
{
	USES_CONVERSION;

	HRESULT hr = S_OK;

	CComPtr<MSXML::IXMLDOMNode> spiXmlNode;
	CComPtr<MSXML::IXMLDOMDocument> spiXmlDocument;

	hr = ::GetXmlNodeFromVariant(	varFileNameOrXmlNode, 
									&spiXmlNode, 
									T2OLE(const_cast<TCHAR*>(m_strXmlTagName.c_str())),
									&spiXmlDocument);
	VERIFY_HR_COND(hr, spiXmlNode, 
		_T("Failed to create XML document."), ILXLOG_ERROR);
	if (FAILED(hr)) return hr;

	_ASSERTE(spiXmlNode);
	if (!spiXmlNode) return E_UNEXPECTED;

	hr = save(spiXmlNode, nIndentLevel);
	VERIFY_HR(hr, _T("Failed to save CXmlElements."), ILXLOG_ERROR);

	if (hr == S_FALSE)
	{
		// We've been told not to save this element
		return S_FALSE;
	}

	if (spiXmlDocument && 
		varFileNameOrXmlNode.vt == VT_BSTR && 
		varFileNameOrXmlNode.bstrVal && 
		*varFileNameOrXmlNode.bstrVal)
	{
		hr = spiXmlDocument->save(varFileNameOrXmlNode);
		VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to save XML document '%s'."), 
			varFileNameOrXmlNode.bstrVal);

		ILXLOGMSG2(ILXLOG_SUCCESS, _T("Saved '%s' XML elements to '%s'."),
			m_strXmlTagName.c_str(),
			varFileNameOrXmlNode.bstrVal);
	}

	return S_OK;
}

HRESULT CXmlElement::save(MSXML::IXMLDOMNode* piNode, long nIndentLevel)
{
	USES_CONVERSION;

	HRESULT hr = S_OK;

	hr = beforeSave();
	VERIFY_HR(hr, _T("beforeSave() failed."), ILXLOG_ERROR);

	if (hr == S_FALSE)
	{
		// We are being told by this element not to save itself or
		// its children
		return S_FALSE;
	}

	// Pre-condition

	bool bXmlTagMatches = false;

	CComBSTR bstrElementName;

	hr = piNode->get_nodeName(&bstrElementName);
	if (hr != S_OK || !bstrElementName)
	{
		hr = FAILED(hr) ? hr : E_FAIL;
		ILXLOG(hr, _T("Failed to retrieve the node name."), ILXLOG_ERROR);
		_ASSERTE(false);
	}

	if (bstrElementName.Length() > 0 &&
		_tcsicmp(OLE2CT(bstrElementName), m_strXmlTagName.c_str()) == 0 ||
		_tcsicmp(OLE2CT(bstrElementName), m_strXmlTagName2.c_str()) == 0)
	{
		bXmlTagMatches = true;
	}
	else
	{
		bXmlTagMatches = false;
	}

	if (!bXmlTagMatches && m_bValidateXmlTagOnLoad)
	{
		ILXLOGMSG1(	ILXLOG_ERROR,
					_T("CXmlElement::save() error - Attempted to save a ")
					_T("CXmlElement subclass using an incompatible XML node: '%ls'."),
					bstrElementName);
		_ASSERTE(false);
		return E_UNEXPECTED;
	}

	if (bXmlTagMatches)
	{
		// Step 1:	Save the attributes

		hr = ::SaveAttributesToXML(piNode, m_mapAttributes);
		VERIFY_HR(hr, _T("Failed to save the attributes."), ILXLOG_ERROR);
	}

	const _variant_t& varSrc = getAttribute(strSRC_ATTR);
	if (varSrc.vt == VT_BSTR && varSrc.bstrVal && *varSrc.bstrVal)
	{
		hr = saveChildren(OLE2CT(varSrc.bstrVal), nIndentLevel);
		VERIFY_HR(hr, _T("Failed to save the XML children."), ILXLOG_ERROR);
	}
	else
	{
		hr = saveChildren(piNode, nIndentLevel);
		VERIFY_HR(hr, _T("Failed to save the XML children."), ILXLOG_ERROR);
	}

	return S_OK;
}

HRESULT CXmlElement::saveChildren(const TCHAR* szFilePath, long nIndentLevel)
{
	USES_CONVERSION;

	if (!szFilePath || !*szFilePath) return E_POINTER;

	HRESULT hr = S_OK;

	CComPtr<MSXML::IXMLDOMNode> spiXmlNode;
	CComPtr<MSXML::IXMLDOMDocument> spiXmlDocument;

	hr = ::GetXmlNodeFromVariant(	CComVariant(szFilePath), 
									&spiXmlNode, 
									T2OLE(const_cast<TCHAR*>(m_strXmlTagName.c_str())),
									&spiXmlDocument);
	VERIFY_HR_COND1(hr, spiXmlNode && spiXmlDocument, ILXLOG_ERROR,
		_T("Failed to save XML document '%s'."), szFilePath);

	hr = saveChildren(spiXmlNode, nIndentLevel);
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to load XML children from '%ls'."), 
		szFilePath);

	hr = spiXmlDocument->save(CComVariant(szFilePath));
	VERIFY_HR1(hr, ILXLOG_ERROR, _T("Failed to save XML document '%s'."), szFilePath);

	ILXLOGMSG2(ILXLOG_SUCCESS, _T("Saved '%s' XML elements to '%s'."),
		m_strXmlTagName.c_str(),
		szFilePath);

	return S_OK;
}

HRESULT CXmlElement::saveChildren(MSXML::IXMLDOMNode* piParentNode, 
								  long nIndentLevel)
{
	HRESULT hr = S_OK;

	const _bstr_t& bstrXmlTagName = m_strXmlTagName.c_str();

	MSXML::IXMLDOMDocumentPtr spiXmlDocument = 0;
	hr = piParentNode->get_ownerDocument(&spiXmlDocument);
	VERIFY_HR(hr, _T("Failed to get the owner document."), ILXLOG_ERROR);

	// Create whitespace for pretty printing

	TCHAR szIndent[200];

	szIndent[0] = _T('\n');
	szIndent[1] = _T('\0');

	++nIndentLevel; // Set indent level for children

	if (nIndentLevel > 0 && nIndentLevel < 100)
	{
		for(int i = 1; i <= nIndentLevel; ++i) szIndent[i] = _T('\t');
		szIndent[i] = _T('\0');
	}
	else if (nIndentLevel >= 100)
	{
		_ASSERTE(!"Unexpected XML node nesting depth");
	}

	// Step 2:	Save all the children

	long nSavedChildren = 0;

	for(TypeVecXmlElementPtrs::iterator it = m_vecChildren.begin();
		it != m_vecChildren.end();
		++it)
	{
		CXmlElement* pChildElement = *it;
		_ASSERTE(pChildElement);

		// Step 3:	Create a new element

		CComPtr<MSXML::IXMLDOMElement> spiNewElement;
		hr = spiXmlDocument->createElement(bstrXmlTagName, &spiNewElement);
		VERIFY_HR(hr, _T("Failed to create a new GroupNode element."), ILXLOG_ERROR);

		// Step 4:	Save the child

		hr = pChildElement->save(spiNewElement, nIndentLevel);
		VERIFY_HR(hr, _T("Failed to save child GroupNode."), ILXLOG_ERROR);

		if (hr == S_FALSE)
		{
			// We've been told not to save this child element
			continue;
		}

		hr = AppendWhitespace(spiXmlDocument, piParentNode, szIndent);
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add whitespace."), ILXLOG_INFO);
		}

		// Step 5:	Append new element to parent

		CComPtr<MSXML::IXMLDOMNode> spiChildNode;
		hr = piParentNode->appendChild(spiNewElement, &spiChildNode);
		VERIFY_HR(hr, _T("Failed to append new GroupNode to parent."), ILXLOG_ERROR);

		++nSavedChildren;
	} 

	// Add whitespace for the closing element tag
	if (nSavedChildren > 0)
	{
		szIndent[_tcslen(szIndent)-1] = _T('\0');

		hr = AppendWhitespace(spiXmlDocument, piParentNode, szIndent);
		if (FAILED(hr))
		{
			ILXLOG(hr, _T("Failed to add whitespace."), ILXLOG_INFO);
		}
	}

	return S_OK;
}

HRESULT CXmlElement::beforeSave()
{
	return S_OK;
}

const tstring& CXmlElement::getElementName() const
{
	return m_strXmlTagName;
}

const tstring& CXmlElement::getSubType() const
{
	return m_strSubType;
}

const OLECHAR* CXmlElement::getNameAttr() const
{
	TypeMapStr2Var::const_iterator it_find = m_mapAttributes.find(szNAME_ATTR);

	if (it_find == m_mapAttributes.end())
	{
		return 0;
	}

	const _variant_t& varName = (*it_find).second;
	if (varName.vt != VT_BSTR) 
	{
		return 0;
	}
	else
	{
		return varName.bstrVal;
	}
}

bool CXmlElement::isLoaded() const
{
	return m_bIsLoaded;
}

const _variant_t& CXmlElement::getAttribute(const tstring& strName) const
{
	static const _variant_t varEMPTY;

	TypeMapStr2Var::const_iterator it_find = m_mapAttributes.find(strName);

	if (it_find == m_mapAttributes.end())
	{
		return varEMPTY;
	}
	else
	{
		return (*it_find).second;
	}
}

_variant_t& CXmlElement::getAttribute(const tstring& strName)
{
	return m_mapAttributes[strName];
}

void CXmlElement::setAttribute(const TCHAR* szName, const _variant_t& varValue)
{
	_ASSERTE(szName && *szName);

	m_mapAttributes[szName] = varValue;
}

// HELPER FUNCTIONS

HRESULT GetXmlNodeFromVariant(	VARIANT varFileNameOrNode,
								MSXML::IXMLDOMNode** ppiXmlNode,
								BSTR bstrRootElementForNewDocument,
								MSXML::IXMLDOMDocument** ppiXmlDocument)
{
	USES_CONVERSION;

	if (!ppiXmlNode || *ppiXmlNode) return E_POINTER;

	if (bstrRootElementForNewDocument && !*bstrRootElementForNewDocument)
		return E_INVALIDARG;

	if (ppiXmlDocument && *ppiXmlDocument) 
		return E_INVALIDARG; // Forget to Release()?

	HRESULT hr = S_OK;

	IUnknown* piUnkNode = 0;
	BSTR bstrFileName = 0;

	// Step 1:	Unwrap the BSTR or XML Node

	if (varFileNameOrNode.vt == VT_BSTR)
	{
		bstrFileName = varFileNameOrNode.bstrVal;
		if (!bstrFileName) return E_POINTER;
		if (!*bstrFileName) return E_INVALIDARG;
	}
	else if (varFileNameOrNode.vt == VT_UNKNOWN)
	{
		piUnkNode = varFileNameOrNode.punkVal;
		if (!piUnkNode) return E_POINTER;
	}
	else if (varFileNameOrNode.vt == VT_DISPATCH)
	{
		piUnkNode = varFileNameOrNode.pdispVal;
		if (!piUnkNode) return E_POINTER;
	}
	else if (varFileNameOrNode.vt == (VT_VARIANT|VT_BYREF))
	{
		if (!varFileNameOrNode.pvarVal) return E_POINTER;

		if (varFileNameOrNode.pvarVal->vt == VT_BSTR)
		{
			bstrFileName = varFileNameOrNode.pvarVal->bstrVal;
			if (!bstrFileName) return E_POINTER;
			if (!*bstrFileName) return E_INVALIDARG;
		}
		else if (varFileNameOrNode.pvarVal->vt == VT_UNKNOWN)
		{
			piUnkNode = varFileNameOrNode.pvarVal->punkVal;
			if (!piUnkNode) return E_POINTER;
		}
		else if (varFileNameOrNode.pvarVal->vt == VT_DISPATCH)
		{
			piUnkNode = varFileNameOrNode.pvarVal->pdispVal;
			if (!piUnkNode) return E_POINTER;
		}
		else
		{
			return E_INVALIDARG;
		}
	}
	else
	{
		return E_INVALIDARG;
	}

	_ASSERTE(piUnkNode || bstrFileName);
	_ASSERTE(!(piUnkNode && bstrFileName));

	if (!piUnkNode && !bstrFileName) return E_INVALIDARG;
	if (piUnkNode && bstrFileName) return E_UNEXPECTED;

	// Step 2:	Get the XML Node

	if (piUnkNode)
	{
		// If the IUnknown was given then just query for the Node

		hr = piUnkNode->QueryInterface(MSXML::IID_IXMLDOMNode, (void**) ppiXmlNode);
		if (FAILED(hr) || !piUnkNode)
		{
			hr = FAILED(hr) ? hr : E_UNEXPECTED;
			return hr;
		}
	}
	else if (bstrFileName && *bstrFileName)
	{
		// Step 3:	Create the XML document

		CComVariant varUrlString(bstrFileName);

		CComPtr<MSXML::IXMLDOMDocument> spiXmlDocument;

		hr = spiXmlDocument.CoCreateInstance(MSXML::CLSID_DOMDocument);
		VERIFY_HR_COND(hr, spiXmlDocument, _T("Failed to create XML parser."), ILXLOG_ERROR);

		if (bstrRootElementForNewDocument)
		{
			// Step 4:	Create the top-level node

			hr = AppendILXComment2(	spiXmlDocument, 
									OLE2CT(bstrFileName),
									true,
									_T(""),
									_T("This file was automatically generated."));
			if (FAILED(hr))
			{
				ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to append comment to XML file '%ls'."), 
					bstrFileName);
			}

			CComPtr<MSXML::IXMLDOMElement> spiTopElement;
			hr = spiXmlDocument->createElement(	bstrRootElementForNewDocument, 
												&spiTopElement);
			VERIFY_HR_COND(hr, hr == S_OK && spiTopElement,
				_T("Failed to create top-level XML element."), ILXLOG_ERROR);

			hr = spiXmlDocument->appendChild(spiTopElement, ppiXmlNode);
			VERIFY_HR_COND(hr, hr == S_OK && *ppiXmlNode,
				_T("Failed to append child XML element."), ILXLOG_ERROR);

			_ASSERTE(ppiXmlDocument);
			if (ppiXmlDocument)
			{
				hr = spiXmlDocument.CopyTo(ppiXmlDocument);
				VERIFY_HR(hr, _T("Failed to copy iface ptr."), ILXLOG_ERROR);
			}
		}
		else
		{
			// Step 5:	Load the XML file
			VARIANT_BOOL bIsSuccessful = VARIANT_FALSE;
			hr = spiXmlDocument->load(varUrlString, &bIsSuccessful);
			if (FAILED(hr))
			{
				return ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to load XML file '%s'."), 
					bstrFileName);
			}
			else if (!bIsSuccessful)
			{
				#ifndef DONT_USE_ILX_LOG
				hr = ::LogXmlError(spiXmlDocument);
				#else
				hr = E_FAIL;
				#endif

				if (hr == INET_E_RESOURCE_NOT_FOUND ||
					hr == INET_E_OBJECT_NOT_FOUND)
				{
					return ILXLOG1(hr, ILXLOG_INFO, _T("Failed to load XML file '%s'."), 
						bstrFileName);
				}
				else
				{
					return ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to load XML file '%s'."), 
						bstrFileName);
				}
			}

			// Step 5:	Get the top-level XML Element

			CComPtr<MSXML::IXMLDOMElement> spiXmlElement;
			hr = spiXmlDocument->get_documentElement(&spiXmlElement);
			if (hr != S_OK || !spiXmlElement)
			{
				hr = FAILED(hr) ? hr : E_UNEXPECTED;
				return ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to get the document element for XML file '%s'."), 
					bstrFileName);
			}

			// Step 6:	Tranform it into a node

			hr = spiXmlElement->QueryInterface(ppiXmlNode);
			if (FAILED(hr) || !*ppiXmlNode)
			{
				hr = FAILED(hr) ? hr : E_UNEXPECTED;
				return ILXLOG1(hr, ILXLOG_ERROR, _T("Failed to QI for XML node for XML file '%s'."), 
					bstrFileName);
			}
		}
	}
	else
	{
		return E_UNEXPECTED;
	}

	_ASSERTE(*ppiXmlNode);
	if (!*ppiXmlNode) return E_UNEXPECTED;

	return S_OK;
}
