///////////////////////////////////////////////////////////////////////
//  Copyright (C) ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/XmlLogHelper.h,v 1.1 2004/09/07 06:10:52 me133 Exp $
//
//    File name:	XmlLogHelper.h
//   Created By:	Marc Eaddy
//   Created on:	8/13/99 6:26:59 PM
//
//      Purpose:	Logs error info from XML document
//
//  Description:	You should call this if IXMLDOMDocument::load()
//					returns S_FALSE or a false success flag.
//
//					Uses the IILXLog component to log errors.  If the
//					error is INET_E_RESOURCE_NOT_FOUND then it is
//					logged as an information message.  Otherwise its
//					logged as an error message.
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: XmlLogHelper.h,v $
 * Revision 1.1  2004/09/07 06:10:52  me133
 * o Initial checkin to CVS
 * 
 * 
 * 4     11/10/00 4:45p Marce
 * o Comments
 * 
 * 3     11/10/00 4:39p Marce
 * o Changed function name for clarity
 */

#ifndef INCLUDED_XML_LOG_HELPER_H
#define INCLUDED_XML_LOG_HELPER_H

// Forward declare the IXMLDOMDocument interface.  This wierd syntax
// is needed because we have to exactly match the real declaration.
#ifndef INCLUDED_MSXML_TYPE_LIBRARY
namespace MSXML
{
	// Stolen from msxml.tlh
	struct __declspec(uuid("2933bf81-7b36-11d2-b20e-00c04f983e60"))
	/* dual interface */ IXMLDOMDocument;
};
#endif // INCLUDED_MSXML_TYPE_LIBRARY

HRESULT LogXmlError(MSXML::IXMLDOMDocument* piXmlDocument);
	//
	// Logs the error info provided by the document.
	//
	// Returns the error code from the error info.
	// 

#endif // INCLUDED_XML_LOG_HELPER_H