///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/COMStuff.h 2     5/28/05 1:20p Eaddy $
//
//    File name:	COMStuff.h
//   Created By:	Marc Eaddy
//   Created on:	10/10/04
//
//      Purpose:	
//
//  Description:	Adapted from Matt Pietrek's DNProfiler
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/COMStuff.h $
 * 
 * 2     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.2  2004/10/10 06:07:44  me133
 * o Added header comment
 *
 */

#ifndef INCLUDED_COM_STUFF_H
#define INCLUDED_COM_STUFF_H

#include <unknwn.h>

#define COM_METHOD( TYPE ) TYPE STDMETHODCALLTYPE

//=============================================================
// CClassFactory
//=============================================================

class CClassFactory : public IClassFactory
{
public:
    CClassFactory();
	virtual ~CClassFactory();

    COM_METHOD( ULONG ) AddRef();
	COM_METHOD( ULONG ) Release();
    COM_METHOD( HRESULT ) QueryInterface(REFIID riid, void **ppInterface );         
    
    // IClassFactory methods
    COM_METHOD( HRESULT ) LockServer( BOOL fLock );
    COM_METHOD( HRESULT ) CreateInstance(	IUnknown *pUnkOuter,
                                            REFIID riid,
                                            void **ppInterface );
private: // DATA
    long m_refCount;                        
};

#endif // INCLUDED_COM_STUFF_H
