///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/CompileInfo.h 7     5/28/05 1:20p Eaddy $
//
//    File name:	CompileInfo.h
//   Created By:	Marc Eaddy
//   Created on:	2/25/05
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/CompileInfo.h $
 * 
 * 7     5/28/05 1:20p Eaddy
 * Changed copyright
 */

#ifndef INCLUDED_COMPILE_INFO_H
#define INCLUDED_COMPILE_INFO_H

#include <vector>				// STL vector
#include <string>				// STL wstring

// Type defines
typedef std::vector<std::wstring>	TypeVecStrings;

class CCompileInfo
{
public:
	CCompileInfo();
	virtual ~CCompileInfo();

	HRESULT findAndLoad(/*[in]*/ const WCHAR* szAssemblyFilePath);

	virtual HRESULT read(FILE* in, bool bIsUnicode, const WCHAR* szCompileInfoFilePath) = 0;
	virtual const WCHAR* getFileExtension() const = 0;

	const WCHAR* getCompilerName() const;
	const WCHAR* getCompilerOptions() const;

	bool getDebugFlag() const;

	size_t getSourceFileCount() const;
	const WCHAR* getSourceFileName(size_t nIndex) const;

	void debugPrint(int nIndentLevel=0) const;

private: // NOT IMPLEMENTED
	CCompileInfo(const CCompileInfo&);
	CCompileInfo& operator=(const CCompileInfo&);

protected: // DATA
	std::wstring	m_strCompilerName;
	std::wstring	m_strCompilerOptions;
	bool			m_bDebugFlag;
	TypeVecStrings	m_vecSourceFiles;
};

#endif // INCLUDED_COMPILE_INFO_H
