///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/Helpers.h 3     5/28/05 1:20p Eaddy $
//
//    File name:	Helpers.h
//   Created By:	Marc Eaddy
//   Created on:	10/10/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/Helpers.h $
 * 
 * 3     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.4  2004/10/17 08:46:52  me133
 * o Now uses the incremental file info to pass the correct compile settings
 * to Watcher. Still need to pass resource files.  We aren't able to parse
 * the incr file in all cases (Text3D.exe.incr built with /debug).
 *
 * Revision 1.3  2004/10/17 00:24:55  me133
 * o Now provides a class-based iface to get to the incremental file info
 *
 * Revision 1.2  2004/10/10 06:07:44  me133
 * o Added header comment
 */

#ifndef INCLUDED_HELPERS_H
#define INCLUDED_HELPERS_H

#include <cor.h>			// Needed to compile corprof.h!!
#include <corprof.h>		// ICorProfilerCallback

#include <string>			// STL wstring

//
// DebugBreak
//
#undef MyDebugBreak
#ifdef _X86_
    #define MyDebugBreak() __asm { int 3 }

#else
    #define MyDebugBreak() DebugBreak()
#endif // _X86_

enum EDispatchThreadWaitStatus
{
	DISPATCH_THREAD_WAIT_ERROR			= 0,
	DISPATCH_THREAD_EVENT_WAITING		= 1,
	DISPATCH_THREAD_SHUTDOWN_SIGNALED	= 2
};

DWORD ExtractPreStubFuncAddr(FunctionID functionID);

HRESULT SetFunctionReJITBugFix(ICorProfilerInfo* piProfInfo, 
							   FunctionID functionID,
							   DWORD dwPfnThePreStubFunc);

EDispatchThreadWaitStatus WaitForDispatchThreadEvents(
							HANDLE hQueuedObjectAvailable, 
							HANDLE hEventDispatchThreadPleaseTerminate);

void GetRotorAndCLRInfo(bool* pbIsRotor, 
						bool* pbIsDebugBuild,
						char* szClixPath,
						int nMaxClixPathLen);

STDAPI MyCoCreateInstance(	REFCLSID rclsid,
							LPUNKNOWN pUnkOuter,
							DWORD dwClsContext,
							REFIID riid,
							LPVOID* ppv);


void AppendMsg(char* szMsg, const char* szAppend, const char* szSeparator=", ");
void AppendMsg(std::wstring str, const WCHAR* szAppend, const WCHAR* szSeparator=L", ");
void AppendMsgWithIndent(char* szMsg, const char* szAppend, int nIndentLevel, const char* szSeparator=", ");
void AppendString(char* szMsg, const char* szName, const char* szValue, const char* szSeparator=", ");
void AppendFlag(char* szMsg, const char* szName, bool bValue, const char* szSeparator=", ");
void AppendNum(char* szMsg, const char* szName, DWORD nValue, const char* szSeparator=", ");
void AppendNumHex(char* szMsg, const char* szName, DWORD nValue, const char* szSeparator=", ");
void AppendTime(char* szMsg, const char* szName, FILETIME fileTime, const char* szSeparator=", ");
void AppendBitSet(char* szMsg, const char* szName, 
				const BYTE* pBitset, unsigned int nNumBytes, const char* szSeparator=", ");
void AppendIndent(char* szMsg, int nIndentLevel);

HRESULT ReadUnicodeOrASCIILineFromFile(FILE* in, bool bIsUnicode, char* buffer, int nMaxLen);

#endif // INCLUDED_HELPERS_H
