///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/MetadataHelpers.h 4     12/08/05 8:28p Eaddy $
//
//    File name:	MetadataHelpers.h
//   Created By:	Marc Eaddy
//   Created on:	10/10/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/MetadataHelpers.h $
 * 
 * 4     12/08/05 8:28p Eaddy
 * o Added Sig2String
 * 
 * 3     12/07/05 7:52p Eaddy
 * o Added Token2TypeName
 * 
 * 2     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.5  2004/10/25 01:03:49  me133
 * o Method IL comparison is now complete and correct
 *
 * Revision 1.4  2004/10/17 08:46:52  me133
 * o Now uses the incremental file info to pass the correct compile settings
 * to Watcher. Still need to pass resource files.  We aren't able to parse
 * the incr file in all cases (Text3D.exe.incr built with /debug).
 *
 * Revision 1.3  2004/10/11 23:22:52  me133
 * o Patch now contains method name
 * o We now skip over methods we couldn't lookup (instead of crashing)
 * o Uses IsBadReadPtr() to avoid access violations when we fail to lookup
 * a method
 *
 * Revision 1.2  2004/10/10 06:07:45  me133
 * o Added header comment
 *
 */

#ifndef INCLUDED_METADATA_HELPERS_H
#define INCLUDED_METADATA_HELPERS_H

#include <cor.h>	// IMetaDataImport
#include <corhdr.h>	// mdToken

HRESULT MyGetMapViewOfFile(	const char* szFile, 
							PBYTE* ppbMap, 
							DWORD* pdwFileSize);

HRESULT MyFindMetaData(	PVOID pImage, 
						DWORD dwFileLength,
						PVOID* ppMetaData, 
						ULONG* pcbMetaData);

const WCHAR* Token2TypeName(mdToken tok);

void Sig2String(	IMetaDataImport* piImport, 
					PCCOR_SIGNATURE pbSigBlob, 
					ULONG ulSigBlob, 
					WCHAR* szBuf,
					int nMaxLen);

#endif // INCLUDED_METADATA_HELPERS_H
