///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/ParamInfo.h 2     5/28/05 1:20p Eaddy $
//
//    File name:	ParamInfo.h
//   Created By:	Marc Eaddy
//   Created on:	10/24/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/ParamInfo.h $
 * 
 * 2     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.1  2004/10/25 01:03:49  me133
 * o Method IL comparison is now complete and correct
 *
 */

#ifndef INCLUDED_PARAM_INFO_H
#define INCLUDED_PARAM_INFO_H

#include "MetadataIterators.h"	// paramDef_iterator

#include "corhlpr.h"			// IMetaDataImport, mdParamDef

class CParamInfo
{
public:

	CParamInfo(IMetaDataImport* piImport, mdParamDef paramDef);
	CParamInfo(paramDef_iterator& itParamDef);

private: // HELPER FUNCTIONS

	HRESULT init(IMetaDataImport* piImport, mdParamDef paramDef);

public: // DATA
    mdMethodDef m_methodDef;
    ULONG m_ulNum;
    WCHAR m_szParamName[MAX_PATH];
    ULONG m_ulNameLen;
    DWORD m_dwFlags;
    DWORD m_dwCPlusFlags;
    CComVariant m_varDefaultValue;
    void const* m_pValue;
    ULONG m_cbValue;
};

static bool operator==(const CParamInfo& lhs, const CParamInfo& rhs);
static bool operator!=(const CParamInfo& lhs, const CParamInfo& rhs);

#endif // INCLUDED_PARAM_INFO_H
