public class StackDBCAspect
{
   static int _WICCA_savedCount;
   static int _WICCA_savedTop;

   public static void Invariant(Stack _WICCA_this)
   {
      if (!_WICCA_this.isEmpty && _WICCA_this.top == null)
         throw new System.InvalidOperationException(
            "Class invariant violated: Stack cannot contain null objects");
   }

   public static void PreCond_push(Stack _WICCA_this, object arg1)
   {
      if (arg1 == null)
         throw new System.ArgumentException("Argument cannot be null", "arg1");

      int savedCount = _WICCA_this.count;
   }

   public static void PostCond_push(Stack _WICCA_this, object arg1)
   {
      if (_WICCA_this.isEmpty)
         throw new System.InvalidOperationException(
            "Post-condition violated: Stack is empty after push");

      if (_WICCA_this.top != arg1)
         throw new System.InvalidOperationException(
            "Post-condition violated: Pushed item is not on top of stack");

      if (_WICCA_this.count != _WICCA_savedCount + 1)
         throw new System.InvalidOperationException(
            "Post-condition violated: Stack size did not increase " +
            "by one after push");
   }

   public static void PreCond_pop(Stack _WICCA_this)
   {
      if (_WICCA_this.isEmpty)
         throw new System.InvalidOperationException(
            "Pre-condition violated: Attempted to pop item from empty stack");

      int savedCount = _WICCA_this.count;
      //object savedTop = _WICCA_this.top;
   }

   public static void PostCond_pop(Stack _WICCA_this, object ret)
   {
      if (_WICCA_this.count != _WICCA_savedCount - 1)
         throw new System.InvalidOperationException(
            "Post-condition violated: Stack size did not decrease " +
            "by one after pop");

      //if(_WICCA_savedTop != ret)
      //   throw new System.InvalidOperationException(
      //      "Post-condition violated: Pop did not return top of the stack");
   }

   public static void PreCond_top(Stack _WICCA_this)
   {
      if (_WICCA_this.isEmpty)
         throw new System.InvalidOperationException(
            "Pre-condition violated: Cannot obtain top of an empty stack");
   }
}
