using System.Collections;
using System.Diagnostics;

public class Stack
{
	private ArrayList elements = new ArrayList();

	public void push(object arg1)
	{
		// Preconditions
		StackDBCAspect.PreCond_push(this, arg1);

		elements.Add(arg1);

		// Invariants
		StackDBCAspect.Invariant(this);

		// Post-conditions
		StackDBCAspect.PostCond_push(this, arg1);
	}

	public object pop()
	{
		// Preconditions
		StackDBCAspect.PreCond_pop(this);

		object popped = this.top;

		// Invariants
		StackDBCAspect.Invariant(this);

		elements.RemoveAt(elements.Count-1);

		// Invariants
		StackDBCAspect.Invariant(this);

		// Post-conditions
		StackDBCAspect.PostCond_pop(this, popped);

		return popped;
	}

	public object top
	{
		get {
			// Preconditions
			StackDBCAspect.PreCond_top(this);

			return elements[elements.Count-1];
		}
	}

	public bool isEmpty
	{
		get { return elements.Count == 0; }
	}

	public int count
	{
		get { return elements.Count; }
	}
}
