///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/UpdaterThread.h 4     5/28/05 1:20p Eaddy $
//
//    File name:	UpdaterThread.h
//   Created By:	Marc Eaddy
//   Created on:	10/10/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/UpdaterThread.h $
 * 
 * 4     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.5  2004/10/25 01:03:49  me133
 * o Method IL comparison is now complete and correct
 *
 * Revision 1.4  2004/10/24 19:33:11  me133
 * o Implemented heartbeat message
 * o Created WatcherKeeper thread for starting and stopping the Watcher
 * and for sending the heartbeat message
 * o Now reads Watcher path from env variable
 * o Fixed bug where meerly changing a string didn't cause a change to be
 * detected
 *
 * Revision 1.3  2004/10/17 08:46:53  me133
 * o Now uses the incremental file info to pass the correct compile settings
 * to Watcher. Still need to pass resource files.  We aren't able to parse
 * the incr file in all cases (Text3D.exe.incr built with /debug).
 *
 * Revision 1.2  2004/10/10 06:07:46  me133
 * o Added header comment
 */

#ifndef INCLUDED_UPDATER_THREAD_H
#define INCLUDED_UPDATER_THREAD_H

#include "ModuleInfo.h"			// CModuleQueue
#include "AssemblyDiff.h"		// TypeListFuncIdAndPtr

class CUpdaterArg
{
public:

	CUpdaterArg(	TypeMapMethodInfo* pmapChangedFunctions,
					CRITICAL_SECTION* pListCS,
					DWORD* pdwPfnThePreStubFunc,
					ICorProfilerInfo* piProfInfo,
					int nPortToUse,
					HANDLE hWatcherReadyEvent,
					HANDLE hThreadPleaseTerminate,
					HANDLE hHeartbeatTimer);
	~CUpdaterArg();

public: // DATA
	TypeMapMethodInfo*		m_pmapChangedFunctions;
	CRITICAL_SECTION*		m_pListCS;
	DWORD*					m_pdwPfnThePreStubFunc;
	ICorProfilerInfo*		m_piProfInfo;
	int						m_nPortToUse;
	HANDLE					m_hWatcherReadyEvent;
	HANDLE					m_hThreadPleaseTerminate;
	HANDLE					m_hHeartbeatTimer;
};

void __cdecl UpdaterThreadProc(void* pvSUpdaterArg);

#endif // INCLUDED_UPDATER_THREAD_H
