@setlocal

@set Target=Hello
@set MainEntryPoint=HelloNS.Hello
@set IconFile=
@set DebugTargetDir=.
@set ReleaseTargetDir=.

@set UseRotor=0
@set IsDebug=1
@set IsBugReport=1
@set IsIncremental=0

@set GAC=%WINDIR%\assembly\GAC
@set NET=%WINDIR%\Microsoft.NET\Framework\v1.1.4322
@set ROTOR_DIR=C:\PROJECTS\sharedsourcecli\clr\bin\rotor_x86\checked
@set PATCHER_DIR=.

@set System=%NET%\System.dll

@REM You must specify /win32icon so that the icon shows up in Windows Explorer.
@REM You must specify /resource so that the DirectX Framework associates the icon
@REM with the application window.

@set CSFlags=/target:exe /d:TRACE /d:DEBUG /unsafe /noconfig
@set StackDBCAspectFlags=/target:library /d:TRACE /d:DEBUG /unsafe
@set VBFlags=/nologo /target:exe
@set JSFlags=/target:exe /autoref /print
@set CPPFlags=/nologo /clr
@set CPPLinkFlags=/link /subsystem:console /libpath:C:\VSNET\Vc7\lib
@set VJFlags=/nologo

@set References=/r:%System%
@set JSReferences=%References% /r:%WINDIR%\assembly\gac\microsoft.jscript\7.0.5000.0__b03f5f7f11d50a3a\microsoft.jscript.dll /r:%WINDIR%\assembly\gac\microsoft.vsa\7.0.5000.0__b03f5f7f11d50a3a\microsoft.vsa.dll

@set CSSources=Hello.cs HelloHelper.cs
@set HelloWeavedSources=Hello.weaved.cs HelloHelper.weaved.cs
@set StackSources=Stack.cs StackDriver.cs
@set StackDBCAspectSources=StackDBCAspect.cs Stack.cs
@set VBSources=Hello.vb
@set JSSources=Hello.js
@set CPPSources=Hello.cpp
@set VJSources=Hello.jsl

@if %IsDebug% EQU 1 set CSTargetExe=%DebugTargetDir%\%Target%_CS.exe
@if %IsDebug% NEQ 1 set CSTargetExe=%ReleaseTargetDir%\%Target%_CS.exe
@if %IsDebug% EQU 1 set HelloWeavedTargetExe=%DebugTargetDir%\%Target%_CS.weaved.exe
@if %IsDebug% NEQ 1 set HelloWeavedTargetExe=%ReleaseTargetDir%\%Target%_CS.weaved.exe
@if %IsDebug% EQU 1 set StackTargetExe=%DebugTargetDir%\Stack.exe
@if %IsDebug% NEQ 1 set StackTargetExe=%ReleaseTargetDir%\Stack.exe
@if %IsDebug% EQU 1 set StackDBCAspectTargetExe=%DebugTargetDir%\StackDBCAspect.dll
@if %IsDebug% NEQ 1 set StackDBCAspectTargetExe=%ReleaseTargetDir%\StackDBCAspect.dll
@if %IsDebug% EQU 1 set VBTargetExe=%DebugTargetDir%\%Target%_VB.exe
@if %IsDebug% NEQ 1 set VBTargetExe=%ReleaseTargetDir%\%Target%_VB.exe
@if %IsDebug% EQU 1 set JSTargetExe=%DebugTargetDir%\%Target%_JS.exe
@if %IsDebug% NEQ 1 set JSTargetExe=%ReleaseTargetDir%\%Target%_JS.exe
@if %IsDebug% EQU 1 set CPPTargetExe=%DebugTargetDir%\%Target%_CPP.exe
@if %IsDebug% NEQ 1 set CPPTargetExe=%ReleaseTargetDir%\%Target%_CPP.exe
@if %IsDebug% EQU 1 set VJTargetExe=%DebugTargetDir%\%Target%_VJ.exe
@if %IsDebug% NEQ 1 set VJTargetExe=%ReleaseTargetDir%\%Target%_VJ.exe

@set StackDBCAspectFlags=%StackDBCAspectFlags% /out:%StackDBCAspectTargetExe%
@set StackFlags=%CSFlags% /out:%StackTargetExe%
@set HelloWeavedFlags=%CSFlags% /out:%HelloWeavedTargetExe%
@set CSFlags=%CSFlags% /out:%CSTargetExe%
@set VBFlags=%VBFlags% /out:%VBTargetExe%
@set JSFlags=%JSFlags% /out:%JSTargetExe%
@set CPPLinkFlags=%CPPLinkFlags% /out:%CPPTargetExe%
@set VJFlags=%VJFlags% /out:%VJTargetExe%

@if %IsDebug% EQU 1 set CSFlags=%CSFlags% /debug
@if %IsDebug% EQU 1 set HelloWeavedFlags=%HelloWeavedFlags% /debug
@if %IsDebug% EQU 1 set StackFlags=%StackFlags% /debug
@if %IsDebug% EQU 1 set StackDBCAspectFlags=%StackDBCAspectFlags% /debug
@if %IsDebug% EQU 1 set VBFlags=%VBFlags% /debug
@if %IsDebug% EQU 1 set JSFlags=%JSFlags% /debug
@if %IsDebug% EQU 1 set CPPLinkFlags=%CPPLinkFlags% /debug
@if %IsDebug% EQU 1 set VJFlags=%VJFlags% /debug
@if %IsIncremental% EQU 1 set CSFlags=%CSFlags% /incremental

@if %IsBugReport% EQU 1 set CSFlags=%CSFlags% /bugreport:%CSTargetExe%.bugreport
@if %IsBugReport% EQU 1 set HelloWeavedFlags=%HelloWeavedFlags% /bugreport:%HelloWeavedTargetExe%.bugreport
@if %IsBugReport% EQU 1 set StackFlags=%StackFlags% /bugreport:%StackTargetExe%.bugreport
@if %IsBugReport% EQU 1 set StackDBCAspectFlags=%StackDBCAspectFlags% /bugreport:%StackDBCAspectTargetExe%.bugreport
@if %IsBugReport% EQU 1 set VBFlags=%VBFlags% /bugreport:%VBTargetExe%.bugreport

@if not "%MainEntryPoint%"=="" set CSFlags=%CSFlags% /main:%MainEntryPoint%
@if not "%IconFile%"=="" set CSFlags=%CSFlags% /resource:%IconFile%

@if %UseRotor% EQU 1 set CSC=%ROTOR_DIR%\csc.exe
@if %UseRotor% NEQ 1 set CSC=csc.exe
@if %UseRotor% EQU 1 set VBC=%ROTOR_DIR%\vbc.exe
@if %UseRotor% NEQ 1 set VBC=vbc.exe
@if %UseRotor% EQU 1 set JSC=%ROTOR_DIR%\jsc.exe
@if %UseRotor% NEQ 1 set JSC=jsc.exe
@if %UseRotor% EQU 1 set CLC=%ROTOR_DIR%\cl.exe
@if %UseRotor% NEQ 1 set CLC=cl.exe
@if %UseRotor% EQU 1 set CLC=%ROTOR_DIR%\vjc.exe
@if %UseRotor% NEQ 1 set VJSC=vjc.exe

@if %UseRotor% NEQ 1 set CSFlags=%CSFlags% /nologo
@if %UseRotor% NEQ 1 set HelloWeavedFlags=%HelloWeavedFlags% /nologo
@if %UseRotor% NEQ 1 set StackFlags=%StackFlags% /nologo
@if %UseRotor% NEQ 1 set Resources=%Resources% /win32icon:%Target%.ico

@if exist "%CSTargetExe%" @del "%CSTargetExe%"
@if exist "%CSTargetExe%.pdb" @del "%CSTargetExe%.pdb"
@if exist "%CSTargetExe%.incr" @del "%CSTargetExe%.incr"

@if exist "%HelloWeavedTargetExe%" @del "%HelloWeavedTargetExe%"
@if exist "%HelloWeavedTargetExe%.pdb" @del "%HelloWeavedTargetExe%.pdb"
@if exist "%HelloWeavedTargetExe%.incr" @del "%HelloWeavedTargetExe%.incr"

@if exist "%StackTargetExe%" @del "%StackTargetExe%"
@if exist "%StackTargetExe%.pdb" @del "%StackTargetExe%.pdb"
@if exist "%StackTargetExe%.incr" @del "%StackTargetExe%.incr"

@if exist "%StackDBCAspectTargetExe%" @del "%StackDBCAspectTargetExe%"
@if exist "%StackDBCAspectTargetExe%.pdb" @del "%StackDBCAspectTargetExe%.pdb"
@if exist "%StackDBCAspectTargetExe%.incr" @del "%StackDBCAspectTargetExe%.incr"

@if exist "%VBTargetExe%" @del "%VBTargetExe%"
@if exist "%VBTargetExe%.pdb" @del "%VBTargetExe%.pdb"
@if exist "%VBTargetExe%.incr" @del "%VBTargetExe%.incr"

@if exist "%JSTargetExe%" @del "%JSTargetExe%"
@if exist "%JSTargetExe%.pdb" @del "%JSTargetExe%.pdb"
@if exist "%JSTargetExe%.incr" @del "%JSTargetExe%.incr"

@if exist "%CPPTargetExe%" @del "%CPPTargetExe%"
@if exist "%CPPTargetExe%.pdb" @del "%CPPTargetExe%.pdb"
@if exist "%CPPTargetExe%.incr" @del "%CPPTargetExe%.incr"

@if exist "%VJCTargetExe%" @del "%VJCTargetExe%"
@if exist "%VJCTargetExe%.pdb" @del "%VJCTargetExe%.pdb"
@if exist "%VJCTargetExe%.incr" @del "%VJCTargetExe%.incr"

@set BACKUP=%Cor_Enable_Profiling%
@if "%BACKUP%"=="1" @set Cor_Enable_Profiling=0

@REM Create an empty file so that we don't get prompted when we specify /bugreport
@echo "" > Empty.txt

@echo.

@REM @echo ***** Building C# *****
@REM @%CSC% %CSFlags% %References% %CSSources% < Empty.txt
@REM @echo.

@REM @echo ***** Building C# *****
@REM @%CSC% %HelloWeavedFlags% %References% %HelloWeavedSources% < Empty.txt
@REM @echo.

@echo ***** Building C# *****
@%CSC% %StackFlags% %References% %StackSources% < Empty.txt
@echo.

@REM @echo ***** Building C# *****
@REM @%CSC% %StackDBCAspectFlags% %References% %StackDBCAspectSources% < Empty.txt
@REM @echo.

@REM ****** REMOVE ME ****** REMOVE ME ****** 
@goto :eof

@echo ***** Building C++ *****
@%CLC% %CPPFlags% %CPPSources% %CPPLinkFlags%
@echo.

@echo ***** Building VB.NET *****
@%VBC% %VBFlags% %References% %VBSources% < Empty.txt
@echo.

@echo ***** Building JScript *****
@%JSC% %JSFlags% %JSReferences% %JSSources% < Empty.txt
@echo.

@echo ***** Building J# *****
@%VJSC% %VJFlags% %VJReferecnes% %VJSources% < Empty.txt
@echo.

@del Empty.txt

@if %IsBugReport% EQU 1 echo ### Compiler command line > %JSTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo %JSC% %JSFlags% %JSReferences% %JSSources% >> %JSTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo ### Source file: '%JSSources%' >> %JSTargetExe%.bugreport

@if %IsBugReport% EQU 1 echo ### Compiler command line > %CPPTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo %CLC% %CPPFlags% %CPPSources% %CPPLinkFlags% >> %CPPTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo ### Source file: '%CPPSources%' >> %CPPTargetExe%.bugreport

@if %IsBugReport% EQU 1 echo ### Compiler command line > %VJTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo %VJSC% %VJFlags% %VJReferecnes% %VJSources% >> %VJTargetExe%.bugreport
@if %IsBugReport% EQU 1 echo ### Source file: '%VJSources%' >> %VJTargetExe%.bugreport

@if "%BACKUP%"=="1" call %PATCHER_DIR%\enable.bat
