///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Watcher/ModuleReceiverWorker.cs 3     5/28/05 1:22p Eaddy $
//
//    File name:	ModuleReceiverWorker.cs
//   Created By:	Marc Eaddy
//   Created on:	10/22/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Watcher/ModuleReceiverWorker.cs $
 * 
 * 3     5/28/05 1:22p Eaddy
 * o Changed copyright
 * 
 * 2     5/25/05 6:34p Eaddy
 * o Now uses EnC.Watcher namespace
 * Revision 1.1  2004/10/24 20:32:23  me133
 * no message
 *
 */

using System;
using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Diagnostics;

namespace EnC.Watcher
{
	public delegate void ModuleDelegate(DynModule dynModule);

	class ModuleReceiverWorker : SocketWorker
	{
		ModuleDelegate _moduleCallback = null;

		public ModuleReceiverWorker()
			: base("ModuleReceiverWorker")
		{ }

		public void StartProcessing(	Socket socket, 
										ModuleDelegate moduleCallback)
		{
			// Verify args
			Debug.Assert(moduleCallback != null);

			// Only call StartProcessing() once!
			Debug.Assert(_moduleCallback == null);

			_moduleCallback = moduleCallback;

			StartProcessing(socket);
		}

		override protected void ThreadFuncInnerLoop()
		{
			DynModule dynModule = new DynModule();
			bool bSuccess = dynModule.readFromSocket(_socket);
			if (bSuccess)
			{
				_moduleCallback(dynModule);
			}
		}
	}
}
